*************************************************************
	BLOCK DATA NMTDATA
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	CHARACTER TXTEL(NSORTMAX)*10,TXTSP(2)*2,SCRFILE(100)*60
	COMMON /COMCENY/ NENY,EPSTNY,STEPE      !!! search_of_eny
	COMMON /COMFERM/ NFERMI,EPSFERMI,HFERMI !!! search_of_ef
	COMMON /ACCU/    EPSTOT,EPSRHO,EPSMAG   !!! accuracy
	COMMON /MASHEPS/ EPSMAS                 !!! mashine accuracy
	COMMON /WORD/    NVAL                   !!! record length value
	COMMON /OUT0/    SCRFILE                !!! scratch storage data
	COMMON /TXTEL/   TXTEL,TXTSP            !!! spin labels
*  DIFFERENT INITIALISATIONS FOR PROGRAM:
	DATA NENY/100/        ! max. number of iterations in search eny
	DATA EPSTNY /1.D-10/  ! accuracy in search eny
	DATA STEPE /0.5/      ! init. step in search of eny
	DATA NFERMI/100/      ! number of iterations in search ef
	DATA EPSFERMI /1.D-9/ ! accuracy  in search ef
	DATA HFERMI /0.8/     ! initial step in search ef
	DATA TXTSP/'up','dn'/ ! UP and DOWN spin labels
	DATA EPSTOT/0.D0/     ! Total energy accuracy (reads from inifile)
	DATA EPSRHO/1.D-10/   ! Charge density accuracy
	DATA EPSMAG/1.D-10/   ! Magnetization accuracy
*  DATA DEPENDING ON THE COMPUTER:
* 1) Record lenght value for unformatted output
	DATA NVAL/16/         ! IBM RISC value
*       DATA NVAL/4/          ! DEC VAX  value 
*       DATA NVAL/16/         ! CRAY value 
* 2) Mashine accuracy
	DATA EPSMAS/1.D-15/     
*  SCRATCH STORAGE PATH
	DATA SCRFILE(1)/'/scratch/'/ 
	END
