      SUBROUTINE PRINT1
************************************************************
* Print necessary information                              *
************************************************************
      PRINT1010      
      PRINT1011      
      PRINT1012      
      PRINT1013      
      PRINT1014      
      PRINT1015      
      PRINT1016      
      PRINT1017      
      PRINT1018      
      PRINT1019      
      PRINT1020      
      PRINT1021
      PRINT1022
      PRINT1023
      PRINT1100      
1010  FORMAT(1X,'###################################################')
1011  FORMAT(1X,'# FULL POTENTIAL LINEAR-MUFFIN-TIN-ORBITAL METHOD #')
1012  FORMAT(1X,'#       USING PLANE WAVE REPRESENTATION           #')
1013  FORMAT(1X,'#   Version 1.0 <bands  + density>  Jun.Aug.1994  #')
1014  FORMAT(1X,'#   Version 1.1 <bands  + density>  Jun.Aug.1994  #')
1015  FORMAT(1X,'#   Version 1.2 <bands  + density>  Jun.Aug.1994  #')
1016  FORMAT(1X,'#   Version 1.3 <bands  + density>  Aug.Nov.1994  #')
1017  FORMAT(1X,'#   Version 1.32<+  total  energy>  Nov.Dec.1994  #')
1018  FORMAT(1X,'#   Version 1.35<+  atomic forces>  Mar.Apr.1995  #')
1019  FORMAT(1X,'#   Version 1.40<+  built-in calc>  Nov.Dec.1995  #')
1020  FORMAT(1X,'#   Version 2.01<+  Teilor series>  Jun.Jul.1996  #')
1021  FORMAT(1X,'#   Version 2.10< + Broyden mixng > Oct.Nov.1996  #')
1022  FORMAT(1X,'#   Version 2.20< + LDA+U Hubbard > Nov.Dec.1996  #')
1023  FORMAT(1X,'#   VERSION 2.30< + Spin-orbitted > Nov.Dec.1996  #')
1100  FORMAT(1X,'############ AUTHOR: Sergej Yu.SAVRASOV ###########')
      END


	SUBROUTINE PRINTI
**********************************************************
*  Print input/output data information.                  *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),NKAP(NPANMAX),LR(NSORTMAX)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX),NDIC(3)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX),NDIV(3)
     &    ,NFFTG(3)
	DIMENSION SMT(NSORTMAX),ORTH(2:3)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
	CHARACTER*60 DOSFILE,CONFILE,KOVFILE,PTNFILE,WFFILE,BNDFILE
     &    ,POTFILE,SCFFILE,OUTFILE,FTRFILE,TMPFILE,HUBFILE
	CHARACTER TXTEL(NSORTMAX)*10,TEXT*64
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /CONTROL/MANAGE,LMTO,NLRK,NOVR,NPF           !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /SCF1COM/NITER1                              !!! from init
	COMMON /MIXRHO1/ADMIX1,ADMIN,ADMAX                  !!! from init
	COMMON /MIXMAG1/ADSPIN,ASMIN,ASMAX                  !!! from init
        COMMON /MIXBROY/LBROY,IBROY,ADMIXB,ADMIXH           !!! from init
	COMMON /RELATIV/LR                                  !!! from init
	COMMON /EFERMI/ EF                                  !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                   !!! from init
	COMMON /ACCU/   EPSTOT,EPSRHO,EPSMAG                !!! from init
	COMMON /ACCURG/ EPSR,EPSG                           !!! from init
	COMMON /FFTMESH/NFFTG                               !!! from init
        COMMON /TEILORG/KEYT,BZM                            !!! from teipar
	COMMON /INTTR/  NDIV,NDIC                           !!! from init
	COMMON /LATPAR/ PAR,ORTH                            !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                   !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS               !!! from init
	COMMON /TXTEL/  TXTEL                               !!! from init
	COMMON /TEXT/   TEXT                                !!! from init
        COMMON /ORBS/   NORBS                               !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /EXCH/   IXC,ICHUB                           !!! from init
	COMMON /OUT1/   ICON,IFTR,IKOV,IWF,ITMP,IBND,IPOT,IPTN,IDOS
     &                 ,ISCF,IOUT,IHBR
	COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE,WFFILE,TMPFILE,BNDFILE
     &                 ,POTFILE,PTNFILE,DOSFILE,SCFFILE,OUTFILE,HUBFILE
	COMMON /UNIT/   IUN                                 !!! from init
C  PRINT HEAD
	WRITE(IUN,1000)
1000	FORMAT(/' <<<--- INPUT INIFILE READ --->>>'/)
C  PRINT TITLE
	WRITE(IUN,1010)TEXT
	WRITE(IUN,1020)
1010    FORMAT(1X,A64)
1020    FORMAT(1X,'---------------------------------------------------')
C  PRINT CONTROL PARAMETERS
	WRITE(IUN,1030)
1030    FORMAT(1X,'<CONTROL PARAMETERS>    :')
	IF(MANAGE.EQ.1)WRITE(IUN,1035)
	IF(MANAGE.EQ.2)WRITE(IUN,1040)
	IF(MANAGE.EQ.3)WRITE(IUN,1050)
1035    FORMAT(1X,'lift  = 1',15X,'- Structure part only')
1040    FORMAT(1X,'lift  = 2',15X,'- Self-consistency is off')
1050    FORMAT(1X,'lift  = 3',15X,'- Self-consistency is on')
	IF(LMTO.EQ.1)WRITE(IUN,1060) 
	IF(LMTO.EQ.2)WRITE(IUN,1070) 
1060    FORMAT(1X,'lmto  = 1',15X,'- Unscreened  LMTO is on')
1070    FORMAT(1X,'lmto  = 2',15X,'- Screened TB-LMTO is on')
C       IF(NLRK.EQ.1)WRITE(IUN,1080) 
C       IF(NLRK.EQ.0)WRITE(IUN,1090) 
C1080    FORMAT(1X,'nlrk  = 1',15X,'- Hamiltonian in R-space')
C1090    FORMAT(1X,'nlrk  = 2',15X,'- Hamiltonian in k-space')
	IF(NOVR.EQ.2)WRITE(IUN,1100) 
	IF(NOVR.EQ.1)WRITE(IUN,1110) 
1100    FORMAT(1X,'novr  = 2',15X,'- Overlap matrix via Sdot')
1110    FORMAT(1X,'novr  = 1',15X,'- Overlap matrix via FTR')
	IF(NPF.NE.0)WRITE(IUN,1140) 
	IF(NPF.EQ.0)WRITE(IUN,1150) 
1140    FORMAT(1X,'npf   = 1',15X,'- Atomic forces   are on')
1150    FORMAT(1X,'npf   = 0',15X,'- Atomic forces   are off')
C  EXCHANGE-CORRELATION
	WRITE(IUN,1200)
1200    FORMAT(1X,'<EXCHANGE-CORRELATION>  :')
	IF(IXC.EQ. 0)WRITE(IUN,1210)
	IF(IXC.EQ. 1)WRITE(IUN,1220)
	IF(IXC.EQ. 2)WRITE(IUN,1230)
	IF(IXC.EQ. 3)WRITE(IUN,1240)
	IF(IXC.EQ. 4)WRITE(IUN,1250)
	IF(IXC.EQ. 5)WRITE(IUN,1260)
	IF(IXC.EQ. 6)WRITE(IUN,1270)
	IF(IXC.EQ.-1)WRITE(IUN,1320)
	IF(IXC.EQ.-2)WRITE(IUN,1330)
	IF(IXC.EQ.-3)WRITE(IUN,1340)
	IF(IXC.EQ.-4)WRITE(IUN,1350)
	IF(IXC.EQ.-5)WRITE(IUN,1360)
	IF(IXC.EQ.-6)WRITE(IUN,1370)
        IF(ICHUB.EQ.0)WRITE(IUN,1380)
        NB=INDEX(HUBFILE,' ')
        IF(NB.LT.2)NB=2
        IF(ICHUB.GT.0)WRITE(IUN,1390)HUBFILE(:NB-1)
1210    FORMAT(1X,'ixc   = 0',15X,'- Not included!')
1220    FORMAT(1X,'ixc   =+1',15X,'- Barth-Hedin, no GGA')
1230    FORMAT(1X,'ixc   =+2',15X,'- Gunnarson-Lundqvist, no GGA')
1240    FORMAT(1X,'ixc   =+3',15X,'- Janak-Williams-Morruzi, no GGA')
1250    FORMAT(1X,'ixc   =+4',15X,'- Vosko-Wilk-Nussair, no GGA')
1260    FORMAT(1X,'ixc   =+5',15X,'- Perdew-Wang, no GGA')
1270    FORMAT(1X,'ixc   =+6',15X,'- Gaspar-Kohn-Sham, no GGA')
1320    FORMAT(1X,'ixc   =-1',15X,'- Barth-Hedin + GGA91')
1330    FORMAT(1X,'ixc   =-2',15X,'- Gunnarson-Lundqvist + GGA91')
1340    FORMAT(1X,'ixc   =-3',15X,'- Janak-Williams-Morruzi + GGA91')
1350    FORMAT(1X,'ixc   =-4',15X,'- Vosko-Wilk-Nussair + GGA91')
1360    FORMAT(1X,'ixc   =-5',15X,'- Perdew-Wang + GGA91')
1370    FORMAT(1X,'ixc   =-6',15X,'- Gaspar-Kohn-Sham + GGA91')
1380    FORMAT(1X,'ihub  = 0',15X,'- with no Hubbard correction')
1390    FORMAT(1X,'ihub  > 0',15X,'- with Hubbard correction after ',A)
C  ITERATIVE PROCEDURE LIMITS AND ACCURACY
        IF(MANAGE.EQ.3)THEN
        WRITE(IUN,1410)
1410    FORMAT(1X,'<CONVERGENCY DATA>      :')
        WRITE(IUN,1420)NITER1
1420    FORMAT(1X,'niter =',I3,14X,'- # of iterations')
        WRITE(IUN,1430)EPSTOT
1430    FORMAT(1X,'epstot=',G14.7,3X,'- total energy   convergency')
        WRITE(IUN,1440)EPSRHO
1440    FORMAT(1X,'epsrho=',G14.7,3X,'- charge density convergency')
        IF(NSPIN.EQ.2)WRITE(IUN,1450)EPSMAG
1450    FORMAT(1X,'epsmag=',G14.7,3X,'- magnetization  convergency')
        IF(LBROY.LT.0)THEN
        WRITE(IUN,1455)LBROY
1455    FORMAT(1X,'lbroy =',G14.7,3X,'- Broyden mixing is off     ')
        WRITE(IUN,1460)ADMIX1
1460    FORMAT(1X,'admix =',G14.7,3X,'- initial mixing for density')
        WRITE(IUN,1470)ADMIN
1470    FORMAT(1X,'admin =',G14.7,3X,'- minimal mixing for density')
        WRITE(IUN,1480)ADMAX
1480    FORMAT(1X,'admax =',G14.7,3X,'- maximal mixing for density')
        IF(NSPIN.EQ.2)THEN
        WRITE(IUN,1490)ADSPIN
1490    FORMAT(1X,'asmix =',G14.7,3X,'- initial mixing for magnet.')
        WRITE(IUN,1500)ASMIN
1500    FORMAT(1X,'asmin =',G14.7,3X,'- minimal mixing for magnet.')
        WRITE(IUN,1510)ASMAX
1510    FORMAT(1X,'asmax =',G14.7,3X,'- maximal mixing for magnet.')
        ENDIF
        ELSEIF(LBROY.GE.0)THEN
        WRITE(IUN,1520)LBROY
1520    FORMAT(1X,'lbroy =',I3,14X,'- Broyden mixing is switched')
        WRITE(IUN,1530)IBROY
1530    FORMAT(1X,'ibroy =',I3,14X,'- after  n=ibroy  iterations')
        WRITE(IUN,1540)ADMIXB
1540    FORMAT(1X,'admixb=',G14.7,3X,'- initial guess for Jacobian')
        WRITE(IUN,1550)ADMIXH
1550    FORMAT(1X,'admixh=',G14.7,3X,'- mixing for high-l (>lbroy)')
        ENDIF
        ENDIF
C  ATOMIC DATA
	WRITE(IUN,1610)
1610    FORMAT(1X,'<ATOMIC DATA>           :')
	WRITE(IUN,1620)NATOM
	WRITE(IUN,1630)NSORT
1620    FORMAT(1X,'natom =',I3,14X,'- # of atoms in unit-cell')
1630    FORMAT(1X,'nsort =',I3,14X,'- # of atoms of different type')
	WRITE(IUN,1640)PAR
1640    FORMAT(1X,'par   =',G14.7,3X,'- lattice parameter in a.u.')
        IF(NSPIN.EQ.1)WRITE(IUN,1650)
        IF(NSPIN.EQ.2)WRITE(IUN,1651)
1650    FORMAT(1X,'nspin = 1',15X,'- no spin-polarization included')
1651    FORMAT(1X,'nspin = 2',15X,'- including spin-polarization')
        IF(NORBS.EQ.1)WRITE(IUN,1652)
        IF(NORBS.EQ.2)WRITE(IUN,1653)
1652    FORMAT(1X,'norbs = 1',15X,'- without spin-orbit coupling  ')
1653    FORMAT(1X,'norbs = 2',15X,'- with spin-orbit coupling   ')
	WRITE(IUN,1670)NKAP(1)
1670    FORMAT(1X,'nkap  =',I2,15X,'- # of kappas in valence panel')
	DO 1690 IKAP=1,NKAP(1)
	WRITE(IUN,1700)IKAP,REAL(EKAP(IKAP,1))
1690    CONTINUE
1700    FORMAT(1X,'Etail',I1,'=',G12.5,5X,'- Hankel tail energy')
C  OUTPUT PARAMETERS
	WRITE(IUN,2000)
2000    FORMAT(1X,'<OUTPUT DATA>           :')
	NB=INDEX(CONFILE,' ')
	IF(ICON.EQ.0)WRITE(IUN,2010)
	IF(ICON.EQ.1)WRITE(IUN,2020)CONFILE(:NB-1)
	IF(ICON.EQ.2)WRITE(IUN,2030)CONFILE(:NB-1)
2010    FORMAT(1X,'icon  = 0',15X,'- no storage of str. const.')
2020    FORMAT(1X,'icon  = 1',15X,'- save str. const. in    ',A)
2030    FORMAT(1X,'icon  = 2',15X,'- read str. const. from  ',A)
	NB=INDEX(FTRFILE,' ')
	IF(IFTR.EQ.0)WRITE(IUN,2040)
	IF(IFTR.EQ.1)WRITE(IUN,2050)FTRFILE(:NB-1)
	IF(IFTR.EQ.2)WRITE(IUN,2060)FTRFILE(:NB-1)
2040    FORMAT(1X,'iftr  = 0',15X,'- no storage fourier con.')
2050    FORMAT(1X,'iftr  = 1',15X,'- save fourier con.in    ',A)
2060    FORMAT(1X,'iftr  = 2',15X,'- read fourier con from  ',A)
	NB=INDEX(BNDFILE,' ')
	IF(    IBND .EQ.0)WRITE(IUN,2070)
	IF(ABS(IBND).EQ.1)WRITE(IUN,2080)BNDFILE(:NB-1)
	IF(    IBND .EQ.2)WRITE(IUN,2090)BNDFILE(:NB-1)
2070    FORMAT(1X,'ibnd  = 0',15X,'- no storage of bands')
2080    FORMAT(1X,'ibnd  = 1',15X,'- save high-sym.bands in ',A)
2090    FORMAT(1X,'ibnd  = 2',15X,'- save tetra.bands    in ',A)
	NB=INDEX(DOSFILE,' ')
	IF(IDOS.EQ.0)WRITE(IUN,2100)
	IF(IDOS.EQ.1)WRITE(IUN,2110)DOSFILE(:NB-1)
2100    FORMAT(1X,'idos  = 0',15X,'- no d.o.s.calculation')
2110    FORMAT(1X,'idos  = 1',15X,'- save partial d.o.s. in ',A)
	NB=INDEX(POTFILE,' ')
	IF(IPOT.EQ.0)WRITE(IUN,2120)
	IF(IPOT.EQ.1)WRITE(IUN,2130)POTFILE(:NB-1)
2120    FORMAT(1X,'ipot  = 0',15X,'- no storage of full potential')
2130    FORMAT(1X,'ipot  = 1',15X,'- save full potential in ',A)
	NB=INDEX(SCFFILE,' ')
	IF(ISCF.EQ.0)WRITE(IUN,2140)
	IF(ISCF.NE.0)WRITE(IUN,2150)SCFFILE(:NB-1)
2140    FORMAT(1X,'iscf  = 0',15X,'- no storage of full density')
2150    FORMAT(1X,'iscf  = 1',15X,'- save full density   in ',A)
	NB=INDEX(OUTFILE,' ')
	IF(IOUT.EQ.0)WRITE(IUN,2160)
	IF(IOUT.EQ.1)WRITE(IUN,2170)OUTFILE(:NB-1)
	IF(IOUT.GT.1)WRITE(IUN,2180)
2160    FORMAT(1X,'iout  = 0',15X,'- no output data file')
2170    FORMAT(1X,'iout  = 1',15X,'- save current output in ',A)
2180    FORMAT(1X,'iout  > 1',15X,'- print current output')
C  OTHER DATA FOR THE CODE
	WRITE(IUN,2200)
2200    FORMAT(1X,'<OTHER DATA>            :') 
	WRITE(IUN,2210)NBNDE(1)-1
	WRITE(IUN,2220)NBNDF(1)-NBNDE(1)+1
2210    FORMAT(1X,'nff   =',I3,14X,'- # of bands below    EF')
2220    FORMAT(1X,'nef   =',I3,14X,'- # of bands crossing EF')
	WRITE(IUN,2230)NDIV
	WRITE(IUN,2240)NDIC
	WRITE(IUN,2250)NFFTG
2230    FORMAT(1X,'ndiv  =',I2,' ',I2,' ',I2,9X,
     &  '- tetr.mesh for valence  panel')
2240    FORMAT(1X,'ndic  =',I2,' ',I2,' ',I2,9X,
     &  '- tetr.mesh for semicore panel')
2250    FORMAT(1X,'nfft  =',I2,' ',I2,' ',I2,9X,
     &  '- fast fourier  transform grid') 
	IF(KEYT.EQ.0)WRITE(IUN,2260)
	IF(KEYT.EQ.1)WRITE(IUN,2270)
2260	FORMAT(1X,'keyt  = 0',15X,'- acceleration is off')
2270	FORMAT(1X,'keyt  = 1',15X,'- acceleration is on ')
	END
	 









	SUBROUTINE PRINTS
***************************************************
*  Print STRFILE data                             *
***************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	CHARACTER*60 STRFILE,KOVFILE,CONFILE,FTRFILE,SYS*1,TXT*72
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NDIV(3),NDIC(3),M3(5)
        DIMENSION ORTH(2:3),TAU(3,NPAT),STRAIN(3,3,2)
     &    ,GBAS(3,3),RBAS(3,3),BBAS(3,3),HSPNT(3,2,KMAX)
     &    ,SH(3,NPANMAX),AK(3,3,2),RK(3,3,2)
	CHARACTER PNTNOT(2,KMAX)*1,TEXT*64,TEXTS*64,TXTEL(NSORTMAX)*10
        COMMON /LATTICE/RBAS,GBAS,AK,RK                 !!! from init
	COMMON /MANSTR/ ISTRAIN,IBAS,IBZ,ICALC          !!! from init
	COMMON /BASIS/  TAU                             !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM   !!! from init
        COMMON /LATPAR/ PAR,ORTH,OMEGAC,STRAIN          !!! from init
	COMMON /OUT1/   ICON,IFTR,IKOV,IWF,ITMP,IBND    !!! from init
        COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE         !!! from init
        COMMON /INTTR/  NDIV,NDIC,SH,NDIR,HSPNT         !!! from init
        COMMON /HSPNTS/ PNTNOT                          !!! from init
	COMMON /STRINP/ NVECMX,ALPHA                    !!! from init
	COMMON /SRFINP/ NDIV1,NDIV2                     !!! from init
        COMMON /TEXT/   TEXT,TEXTS                      !!! from init
	COMMON /TXTEL/  TXTEL                           !!! from init
        COMMON /UNIT/   IUN                             !!! from init
C  PRINT HEAD
	WRITE(IUN,1000)
1000	FORMAT(/'<<<--- INPUT STRFILE READ --->>>'/)
C  PRINT TITLE
	WRITE(IUN,1010)TEXTS
	WRITE(IUN,1020)
1010    FORMAT(1X,A64)
1020    FORMAT(1X,'---------------------------------------------------')
C  PRINT CONTROL PARAMETERS
	WRITE(IUN,1030)
1030    FORMAT(1X,'<CONTROL PARAMETERS>     :')
	WRITE(IUN,1031)NATOM
	WRITE(IUN,1032)ORTH(2)
	WRITE(IUN,1033)ORTH(3)
1031	FORMAT(1X,'natom =',I3,15X,  ' - # of atoms in unit-cell')
1032	FORMAT(1X,'b/a   =',G12.5,6X,' - orthorombicity  along b')
1033	FORMAT(1X,'c/a   =',G12.5,6X,' - orthorombicity  along c')
	IF(IBAS.EQ.1)WRITE(IUN,10301)IBAS
	IF(IBAS.NE.1)WRITE(IUN,10302)IBAS
	IF(IBZ .EQ.1)WRITE(IUN,10303)IBZ
	IF(IBZ .NE.1)WRITE(IUN,10304)IBZ
	IF(ICALC.EQ.1)WRITE(IUN,10305)ICALC
	IF(ICALC.NE.1)WRITE(IUN,10306)ICALC
	IF(ISTRAIN.EQ.1)WRITE(IUN,10307)ISTRAIN
	IF(ISTRAIN.NE.1)WRITE(IUN,10308)ISTRAIN
10301   FORMAT(1X,'ibas  =',I3,15X,  ' - basis in Cartesian sys.')
10302   FORMAT(1X,'ibas  =',I3,15X,  ' - basis in translations  ')
10303   FORMAT(1X,'ibz   =',I3,15X,  ' - automatic BZ - choice  ')
10304   FORMAT(1X,'ibz   =',I3,15X,  ' - read BZ from strfile   ')
10305   FORMAT(1X,'icalc =',I3,15X,  ' - using built-in calc.   ')
10306   FORMAT(1X,'icalc =',I3,15X,  ' - using numerical data   ')
10307   FORMAT(1X,'istrn =',I3,15X,  ' - distort cutoff sphere  ')
10308   FORMAT(1X,'istrn =',I3,15X,  ' - select plws in sphere  ')
	WRITE(IUN,1034)NDIV1
	WRITE(IUN,1035)NDIV2
1034	FORMAT(1X,'ndiv1 =',I3,15X,  ' - polyhedron   generation')
1035	FORMAT(1X,'ndiv2 =',I3,15X,  ' - polyhedron surface grid')
	WRITE(IUN,1036)NVECMX
	WRITE(IUN,1037)ALPHA
1036	FORMAT(1X,'nvec  =',I5,13X,  ' - vectors in Evald method')
1037	FORMAT(1X,'alpha =',G12.5,6X,' - splitting factor  there')
	WRITE(IUN,1040)
1040	FORMAT(1X,'<PRIMITIVE TRANSLATIONS> :')
	WRITE(IUN,1041)(RBAS(J,1),J=1,3)
	WRITE(IUN,1042)(RBAS(J,2),J=1,3)
	WRITE(IUN,1043)(RBAS(J,3),J=1,3)
1041	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! R1x,R1y,R1z')
1042	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! R2x,R2y,R2z')
1043	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! R3x,R3y,R3z')
	WRITE(IUN,1050)
1050	FORMAT(1X,'<BASIS ATOMS IN CELL>    :')
	DO 10 IATOM=1,NATOM
	WRITE(IUN,1051)(TAU(J,IATOM),J=1,3),TXTEL(IS(IATOM))
  10	CONTINUE
1051	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! ',A10)
	WRITE(IUN,1060)
1060	FORMAT(1X,'<STRAIN MATRIX>          :')
	WRITE(IUN,1061)(STRAIN(1,I,1),I=1,3)
	WRITE(IUN,1062)(STRAIN(2,I,1),I=1,3)
	WRITE(IUN,1063)(STRAIN(3,I,1),I=1,3)
1061	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! Sxx,Sxy,Sxz')
1062	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! Syx,Syy,Syz')
1063	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! Szx,Szy,Szz')
	WRITE(IUN,1070)
1070	FORMAT(1X,'<INVERSE STRAIN MATRIX>  :')
	WRITE(IUN,1071)(STRAIN(1,I,2),I=1,3)
	WRITE(IUN,1072)(STRAIN(2,I,2),I=1,3)
	WRITE(IUN,1073)(STRAIN(3,I,2),I=1,3)
1071	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! Rxx,Rxy,Rxz')
1072	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! Ryx,Ryy,Ryz')
1073	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! Rzx,Rzy,Rzz')
	WRITE(IUN,1080)
1080	FORMAT(1X,'<POINT GROUP DESCRIPTION>:')
        NB=INDEX(KOVFILE,' ')
        IF(IKOV.EQ.1)WRITE(IUN,1081)
        IF(IKOV.EQ.2)WRITE(IUN,1082)
        IF(IKOV.EQ.3)WRITE(IUN,1083)KOVFILE(:NB-1)
1081    FORMAT(1X,'ikov  = C  - Cubic system')
1082    FORMAT(1X,'ikov  = H  - Hex.  system')
1083    FORMAT(1X,'ikov  = A  - Arbitray system specified in ',A)
	WRITE(IUN,1090)
1090	FORMAT(1X,'<RECIPROCAL LATTICE>     :')       
	WRITE(IUN,1091)(GBAS(J,1),J=1,3)
	WRITE(IUN,1092)(GBAS(J,2),J=1,3)
	WRITE(IUN,1093)(GBAS(J,3),J=1,3)
1091	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! G1x,G1y,G1z')
1092	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! G2x,G2y,G2z')
1093	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! G3x,G3y,G3z')
	WRITE(IUN,1100)
1100	FORMAT(1X,'<BRILLOUIN ZONE>         :')       
	WRITE(IUN,1101)(AK(J,1,1)*NDIV(1),J=1,3)
	WRITE(IUN,1102)(AK(J,2,1)*NDIV(2),J=1,3)
	WRITE(IUN,1103)(AK(J,3,1)*NDIV(3),J=1,3)
1101	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! K1x,K1y,K1z')
1102	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! K2x,K2y,K2z')
1103	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! K3x,K3y,K3z')
	IF(ABS(IBND).EQ.1)THEN
	WRITE(IUN,1110)
1110	FORMAT(1X,'<HIGH-SYMMETRY LINES>    :')
	WRITE(IUN,1111)NDIR
1111	FORMAT(1X,'ndir  =',I3,15X,' - # of directions in BZ')
	DO 20 IDIR=1,NDIR
	WRITE(IUN,1112)(PNTNOT(K,IDIR),K=1,2)
	WRITE(IUN,1113)(HSPNT(J,1,IDIR),J=1,3)
	WRITE(IUN,1114)(HSPNT(J,2,IDIR),J=1,3)
  20	CONTINUE
1112	FORMAT(1X,A1,'-',A1,10X,' - point notations')
1113	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! lx,ly,1z')
1114	FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ! nx,ny,nz')
	ENDIF
	WRITE(IUN,1200)OMEGAC
1200	FORMAT(1X,'Cell Volume =',G14.7)
	END
