*******************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	CHARACTER*60 INIFILE,SCFFILE,STRFILE
	INTEGER IS(NPAT),ILS(NSORTMAX),NRAD(NSORTMAX)
     &  ,LMSYM(LMMAXV,NPAT),NSYM(NPAT)
	DIMENSION X1(3),X2(3),X3(3),R(0:NRADMAX,NSORTMAX)
     &  ,ORTH(2:3),TAU(3,NPAT),TAU0(3,NPAT),GPLW(3,0:NPLWMAX)
     &  ,WXR1(0:NRADMAX,NSYMMAX,NPAT),WYR1(0:NRADMAX,NSYMMAX,NPAT)
     &  ,WZR1(0:NRADMAX,NSYMMAX,NPAT),WXI1(0:NRADMAX,NSYMMAX,NPAT)
     &  ,WYI1(0:NRADMAX,NSYMMAX,NPAT),WZI1(0:NRADMAX,NSYMMAX,NPAT)
     &  ,FUNR1(0:NRADMAX,NSYMMAX,NPAT),FUNI1(0:NRADMAX,NSYMMAX,NPAT)
     &  ,RBAS(3,3),GBAS(3,3)
	COMPLEX*16 FUN(0:NRADMAX,NSYMMAX,NPAT),YLM(LMMAXV)
     &  ,FUNG(0:NPLWMAX),EXPGR
	LOGICAL SYM(LMMAXV,NPAT)
	COMMON /PARAM/  NSORT,IS,ILS,NATOM,NSPIN
	COMMON /LATTICE/RBAS,GBAS
	COMMON /BASIS/  TAU
	COMMON /BASIS0/ TAU0
	COMMON /RADMESH/NRAD,R
	COMMON /COMFUN/ FUN,FUNG
	COMMON /SYMMLM/ SYM,LMSYM,NSYM
	COMMON /LATPAR/ PAR,ORTH
	COMMON /PLWMESH/NPLW,GPLW
	COMMON /POTCOM/ SWZ,SMT(NSORTMAX)
	COMMON /TXTEL/  TXTEL
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	PRINT1100
	PRINT1110
	PRINT1120
	PRINT1130
	PRINT1131
	PRINT1132
	PRINT1133
	PRINT1134
	PRINT1135
	PRINT1136
	PRINT1137
	PRINT1138
	PRINT1140
	PRINT1150
	PRINT1160
1100    FORMAT(1X,'**************************************************')
1110    FORMAT(1X,'The program MAKEGRID can calculate charge density,')
1120    FORMAT(1X,'magnetisation as well as the full potential either')
1130    FORMAT(1X,'at a plane grid or along given line of the lattice')
1131    FORMAT(1X,'To define plane set three space points as follows:')
1132    FORMAT(1X,'             z ^       r2                         ')
1133    FORMAT(1X,'               |      /                           ')
1134    FORMAT(1X,'               |     /   PLANE                    ')
1135    FORMAT(1X,'               |   r1--------r3                   ')
1136    FORMAT(1X,'               .------------------->              ')
1137    FORMAT(1X,'              /                     x             ')
1138    FORMAT(1X,'            y                                     ')
1140    FORMAT(1X,'Adapted to full potential PW-version of the LMTO, ')
1150    FORMAT(1X,'version 1.40 or later.                            ')
1160    FORMAT(1X,'**************************************************')
	PRINT1002
	READ(5,1001)INIFILE
	PRINT1003
	READ(5,1001)SCFFILE
	PRINT1004
	READ(5,1001)STRFILE
	PRINT1170
1170    FORMAT(1X,'Plot potential[1], density/magnetisation [2/3]? ',$)
	READ(5,*)ISCF
	CALL READINI(INIFILE)
	CALL READSCF(SCFFILE,ISCF)
	CALL READSTR(STRFILE)
	PRINT1180
1180    FORMAT(1X,'Set up  grid along  a line[1] or in a plane[2]? ',$)
	READ(5,*)IPLANE
	IF(IPLANE.EQ.2)THEN
	PRINT1190
1190    FORMAT(1X,  'Set up three space points defining the plane -> ')
	PRINT1200
1200    FORMAT(1X,'r1x, r1y, r1z : ',$)
	READ(5,*)X1
	PRINT1210
1210    FORMAT(1X,'r2x, r2y, r2z : ',$)
	READ(5,*)X2
	PRINT1220
1220    FORMAT(1X,'r3x, r3y, r3z : ',$)
	READ(5,*)X3
	PRINT1230
1230    FORMAT(1X,  'Set up grid size in plane,i.e # of divisions -> ')
	PRINT1240
1240    FORMAT(1X,'[r2-r1]/N1,[r3-r1]/N2, set N1,N2 : ',$)
	READ(5,*)ND1,ND2
C  DEFINE PLANE
	RX=SQRT((X2(1)-X1(1))**2+(X2(2)-X1(2))**2+(X2(3)-X1(3))**2)
	RY=SQRT((X3(1)-X1(1))**2+(X3(2)-X1(2))**2+(X3(3)-X1(3))**2)
	STEPX=RX/DBLE(ND1)
	STEPY=RY/DBLE(ND2)
	ELSEIF(IPLANE.EQ.1)THEN
	PRINT1250
1250    FORMAT(1X,  'Set up  two  space points defining the line  -> ')
	PRINT1260
1260    FORMAT(1X,'r1x, r1y, r1z  : ',$)
	READ(5,*)X1
	PRINT1270
1270    FORMAT(1X,'r2x, r2y, r2z  : ',$)
	READ(5,*)X2
	PRINT1280
1280    FORMAT(1X,  'Set up grid size in line ,i.e # of divisions -> ')
	PRINT1290
1290    FORMAT(1X,'[r2-r1]/N1, N1 ? ',$)
	READ(5,*)ND1
C  DEFINE LINE
	RX=SQRT((X2(1)-X1(1))**2+(X2(2)-X1(2))**2+(X2(3)-X1(3))**2)
	STEPX=RX/DBLE(ND1)
	STEPY=0.D0
	ND2=0
	ENDIF
C  DEFINE SPLINE COEFFICIENTS
	DO 50 IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO 40 L=0,ILS(ISORT)
	DO 30 M=-L,L
	LM=L*(L+1)+1+M
	IF(.NOT.SYM(LM,IATOM))GOTO30
	ISYM=LMSYM(LM,IATOM)
		FRE=0.D0
		FIM=0.D0
		DO 10 IRAD=0,NRAD(ISORT)
		FUNR1(IRAD,ISYM,IATOM)=DREAL(FUN(IRAD,ISYM,IATOM))
		FUNI1(IRAD,ISYM,IATOM)=DIMAG(FUN(IRAD,ISYM,IATOM))
  10            CONTINUE
	CALL SPLKFF(NRAD(ISORT)+1,R(0,ISORT),FUNR1(0,ISYM,IATOM)
     & ,WXR1(0,ISYM,IATOM),WYR1(0,ISYM,IATOM),WZR1(0,ISYM,IATOM))
	CALL SPLKFF(NRAD(ISORT)+1,R(0,ISORT),FUNI1(0,ISYM,IATOM)
     & ,WXI1(0,ISYM,IATOM),WYI1(0,ISYM,IATOM),WZI1(0,ISYM,IATOM))
  30    CONTINUE
  40    CONTINUE
  50    CONTINUE
C
	NX=ND1+1
	NY=ND2+1
C
	IF(IPLANE.EQ.2)OPEN(1,FILE='GRID.DAT',STATUS='NEW')
	IF(IPLANE.EQ.1)OPEN(1,FILE='LINE.DAT',STATUS='NEW')
C       WRITE(1,1010)NX,NY
	DO 100 IX=0,ND1
	XC=DBLE(IX)*STEPX
	DO 90 IY=0,ND2
	YC=DBLE(IY)*STEPY
	IF(IPLANE.EQ.2)THEN
	XX=X1(1)+(X2(1)-X1(1))/DBLE(ND1)*IX+(X3(1)-X1(1))/DBLE(ND2)*IY
	YY=X1(2)+(X2(2)-X1(2))/DBLE(ND1)*IX+(X3(2)-X1(2))/DBLE(ND2)*IY
	ZZ=X1(3)+(X2(3)-X1(3))/DBLE(ND1)*IX+(X3(3)-X1(3))/DBLE(ND2)*IY
	ELSEIF(IPLANE.EQ.1)THEN
	XX=X1(1)+(X2(1)-X1(1))/DBLE(ND1)*DBLE(IX)
	YY=X1(2)+(X2(2)-X1(2))/DBLE(ND1)*DBLE(IX)
	ZZ=X1(3)+(X2(3)-X1(3))/DBLE(ND1)*DBLE(IX)
	ENDIF
	CALL REDFC(XX,YY,ZZ,XR,YR,ZR,XS,YS,ZS,IATOM)
	ZT=0.D0
	IF(IATOM.NE.0)THEN
	ISORT=IS(IATOM)
	RR=DSQRT(XS*XS+YS*YS+ZS*ZS)*PAR
	IF(RR.GE.1.D-10)THEN
	CALL SPHHARM(XS*PAR/RR,YS*PAR/RR,ZS*PAR/RR,ILS(ISORT),YLM)
	DO 80 L=0,ILS(ISORT)
	DO 70 M=-L,L
	LM=L*(L+1)+1+M
	IF(.NOT.SYM(LM,IATOM))GOTO70
	ISYM=LMSYM(LM,IATOM)    
	ZRR=SPLPNT(NRAD(ISORT)+1,RR,R(0,ISORT),FUNR1(0,ISYM,IATOM)
     &  ,WXR1(0,ISYM,IATOM),WYR1(0,ISYM,IATOM),WZR1(0,ISYM,IATOM))
	ZRI=SPLPNT(NRAD(ISORT)+1,RR,R(0,ISORT),FUNI1(0,ISYM,IATOM)
     &  ,WXI1(0,ISYM,IATOM),WYI1(0,ISYM,IATOM),WZI1(0,ISYM,IATOM))
	ZT=ZT+DCMPLX(ZRR,ZRI)*(0.D0,1.D0)**L*YLM(LM)
  70    CONTINUE
  80    CONTINUE
	ELSE
	ZT=FUN(0,1,IATOM)/SQPI4
	ENDIF
	ENDIF
C  FOURIER TRANSFORM
	ZP=0.D0
	DO 85 IPLW=0,NPLW
	SCP=XR*GPLW(1,IPLW)+YR*GPLW(2,IPLW)+ZR*GPLW(3,IPLW)
	EXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	ZP=ZP+FUNG(IPLW)*EXPGR
   85   CONTINUE
	IF(IATOM.NE.0.AND.IPLANE.EQ.2)WRITE(1,1020)XC,YC,ZT,ZP
	IF(IATOM.EQ.0.AND.IPLANE.EQ.2)WRITE(1,1020)XC,YC,ZP,ZP
	IF(IATOM.NE.0.AND.IPLANE.EQ.1)WRITE(1,1030)XC,ZT,ZP
	IF(IATOM.EQ.0.AND.IPLANE.EQ.1)WRITE(1,1030)XC,ZP,ZP
  90    CONTINUE
 100    CONTINUE
1001    FORMAT(A)
1002    FORMAT(1X,'INIFILE? ',$)
1003    FORMAT(1X,'SCFFILE? ',$)
1004    FORMAT(1X,'STRFILE? ',$)
1010    FORMAT(1X,I3,3X,I3)
1020    FORMAT(1X,G14.7,3X,G14.7,3X,G14.7,3X,G14.7)
1030    FORMAT(1X,G14.7,3X,G14.7,3X,G14.7)
	END



	SUBROUTINE REDFC(XX,YY,ZZ,XR,YR,ZR,XS,YS,ZS,IATOM0)
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILS(NSORTMAX),ISVEC(0:NVCMAX*NPAT)
	DIMENSION RBAS(3,3),GBAS(3,3),SMT(NSORTMAX),TAU(3,NPAT)
     &   ,TVEC(3,0:NVCMAX)
	LOGICAL FIRST
	COMMON /PARAM/  NSORT,IS,ILS,NATOM,NSPIN
	COMMON /LATTICE/RBAS,GBAS
	COMMON /BASIS/  TAU
	COMMON /LATPAR/ PAR
	COMMON /POTCOM/ SWZ,SMT
	SAVE ISVEC,TVEC,NVEC
	DATA FIRST/.TRUE./
	SC1=GBAS(1,1)*XX+GBAS(2,1)*YY+GBAS(3,1)*ZZ
	SC2=GBAS(1,2)*XX+GBAS(2,2)*YY+GBAS(3,2)*ZZ
	SC3=GBAS(1,3)*XX+GBAS(2,3)*YY+GBAS(3,3)*ZZ
	SR1=SC1-INT(SC1)
	SR2=SC2-INT(SC2)
	SR3=SC3-INT(SC3)
	IF(SR1.LT.0.D0)SR1=SR1+1.D0
	IF(SR2.LT.0.D0)SR2=SR2+1.D0
	IF(SR3.LT.0.D0)SR3=SR3+1.D0
	XR=RBAS(1,1)*SR1+RBAS(1,2)*SR2+RBAS(1,3)*SR3
	YR=RBAS(2,1)*SR1+RBAS(2,2)*SR2+RBAS(2,3)*SR3
	ZR=RBAS(3,1)*SR1+RBAS(3,2)*SR2+RBAS(3,3)*SR3
	IF(FIRST)THEN
C  FIND SPHERE RADIUS CIRCUMSCRIBING UNIT CELL
	SMAX=0.D0
	DO 25 ISORT=1,NSORT
	SMAX=MAX(SMAX,SMT(ISORT)/PAR)
  25    CONTINUE
	RMAX=0.D0
	DO 40 IZ=-1,1
	DO 40 JZ=-1,1
	DO 40 KZ=-1,1
	RSUM=0.D0
	DO 30 I=1,3
	RSUM=RSUM+(IZ*RBAS(I,1)+JZ*RBAS(I,2)+KZ*RBAS(I,3))**2
  30    CONTINUE
	RMAX=MAX(RMAX,RSUM)
  40    CONTINUE
	RMAX=SQRT(RMAX)+2.D0*SMAX+0.1D0
C  GENERATE ALL LATTICE SITES INSIDE SPHERE "RMAX"
	CALL SITEGEN(RMAX,RBAS(1,1),RBAS(1,2),RBAS(1,3),
     &  TAU,NATOM,NVEC,TVEC(1,0),ISVEC(0))
	NVEC=NVEC-1
	FIRST=.FALSE.
	ENDIF
	IATOM0=0
	DO 50 IVEC=0,NVEC
	TX=TVEC(1,IVEC)
	TY=TVEC(2,IVEC)
	TZ=TVEC(3,IVEC)
	DIF=SQRT((TX-XR)**2+(TY-YR)**2+(TZ-ZR)**2)
	IF(DIF.LE.SMT(IS(ISVEC(IVEC)))/PAR)THEN
	IATOM0=ISVEC(IVEC)
	XS=XR-TX
	YS=YR-TY
	ZS=ZR-TZ
	ENDIF
  50    CONTINUE
	END



	SUBROUTINE READINI(INIFILE)
************************************************************
*  <READINI> reads control parameters,atomic stucture data *
*  iterative procedures limits and accuracy parameters     *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILS(NSORTMAX)
	DIMENSION Z(NSORTMAX),ZCORE(NSORTMAX),SMT(NSORTMAX)
	CHARACTER*60 INIFILE,TXTEL(NSORTMAX)*10
	COMMON /PARAM/   NSORT,IS,ILS,NATOM,NSPIN
	COMMON /POTCOM/  SWZ,SMT
	COMMON /LATPAR/  PAR
	COMMON /TXTEL/   TXTEL
	DATA PI/3.141592653589793D0/
	OPEN(1,FILE=INIFILE,STATUS='OLD')
	DO 10 I=1,13
	READ(1,*)
  10    CONTINUE
	READ(1,*)NATOM,NSORT,NSPIN
	READ(1,*)PAR
	READ(1,*)(IS(I),I=1,NATOM)
	READ(1,*)NKAP
	DO 40 ISORT=1,NSORT
	READ(1,1000)TXTEL(ISORT)
	READ(1,*)Z(ISORT),ZCORE(ISORT)
	READ(1,*)SMT(ISORT)
	READ(1,*)LMT,LMB,ILS(ISORT)
	READ(1,*)
	DO 20 IKAP=1,NKAP
	READ(1,*)
	READ(1,*)
	READ(1,*)
	READ(1,*)
	READ(1,*)
	READ(1,*)
  20    CONTINUE
	READ(1,*)
	READ(1,*)NC
	DO 30 IC=1,NC
	READ(1,*)
  30    CONTINUE
  40    CONTINUE
	CLOSE(1)
1000    FORMAT(A60)
	END


	SUBROUTINE READSCF(SCFFILE,ISCF)
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	CHARACTER*60 SCFFILE
	INTEGER*4 IS(NPAT),ILS(NSORTMAX),NRAD(NSORTMAX),NSYM(NPAT)
     &    ,LMSYM(LMMAXV,NPAT),LMS(NSYMMAX,NPAT)
	DIMENSION R(0:NRADMAX,NSORTMAX),FUNC(0:NRADMAX,NSPINMAX)
     &   ,GPLW(3,0:NPLWMAX)
	COMPLEX*16 FUN(0:NRADMAX,NSYMMAX,NPAT)
     &   ,FUNG(0:NPLWMAX),F(0:NRADMAX,NSPINMAX)
     &   ,FG(0:NPLWMAX,NSPINMAX)
	LOGICAL SYM(LMMAXV,NPAT)
	COMMON /PARAM/   NSORT,IS,ILS,NATOM,NSPIN
	COMMON /RADMESH/ NRAD,R
	COMMON /PLWMESH/ NPLW,GPLW
	COMMON /SYMMLM/  SYM,LMSYM,NSYM
	COMMON /COMFUN/  FUN,FUNG
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	IF(ISCF.EQ.1)THEN
	OPEN(1,FILE=SCFFILE,STATUS='OLD',FORM='UNFORMATTED')
	READ(1)NATOM,NSORT,NSPIN,NPLW,NLIB,(NRAD(ISORT),ISORT=1,
     &  NSORT),(ILS(ISORT),ISORT=1,NSORT),(NSYM(IATOM),IATOM=1,NATOM)
	READ(1)((GPLW(I,IPLW),I=1,3),IPLW=0,NPLW),ORTH
	READ(1)((FG(IPLW,ISPIN),IPLW=0,NPLW),ISPIN=1,NSPIN)
	DO 5 IPLW=0,NPLW
	FUNG(IPLW)=(FG(IPLW,1)+FG(IPLW,NSPIN))/2.D0
   5    CONTINUE
	DO 40 IATOM=1,NATOM
	ISORT=IS(IATOM)
	IF(NRAD(ISORT).GT.NRADMAX)STOP'# OF RADIAL POINTS IS TOO LARGE,
     &  INCREASE NRADMAX IN PARAM.DAT'
C  RADIAL MESHES
	READ(1)(R(I,ISORT),I=0,NRAD(ISORT))
	DO 30 ISYM=1,NSYM(IATOM)
	READ(1)LM
	READ(1)((F(I,ISPIN),I=0,NRAD(ISORT)),ISPIN=1,NSPIN)
	LMS(ISYM,IATOM)=LM
	DO 10 I=0,NRAD(ISORT)
	FUN(I,ISYM,IATOM)=(F(I,1)+F(I,NSPIN))/2.D0
  10    CONTINUE
  30    CONTINUE
	READ(1)
  40    CONTINUE
	CLOSE(1)
	ELSEIF(ISCF.EQ.2.OR.ISCF.EQ.3)THEN
	OPEN(1,FILE=SCFFILE,STATUS='OLD',FORM='UNFORMATTED')
	READ(1)NATOM,NSORT,NSPIN,NPLW,NLIB,(NRAD(ISORT),ISORT=1,
     &  NSORT),(ILS(ISORT),ISORT=1,NSORT),(NSYM(IATOM),IATOM=1,NATOM)
	READ(1)((GPLW(I,IPLW),I=1,3),IPLW=0,NPLW),ORTH
	READ(1)((FG(IPLW,ISPIN),IPLW=0,NPLW),ISPIN=1,NSPIN)
	DO 50 IPLW=0,NPLW
	IF(ISCF.EQ.2)FUNG(IPLW)=(FG(IPLW,1)+FG(IPLW,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	IF(ISCF.EQ.3)FUNG(IPLW)=(FG(IPLW,1)-FG(IPLW,NSPIN))
  50    CONTINUE
	DO 110 IATOM=1,NATOM
	ISORT=IS(IATOM)
	IF(NRAD(ISORT).GT.NRADMAX)STOP'# OF RADIAL POINTS IS TOO LARGE,
     &  INCREASE NRADMAX IN PARAM.DAT'
	READ(1)(R(I,ISORT),I=0,NRAD(ISORT))
	READ(1)
	DO 100 ISYM=1,NSYM(IATOM)
	READ(1)LM
	READ(1)((F(I,ISPIN),I=0,NRAD(ISORT)),ISPIN=1,NSPIN)
	LMS(ISYM,IATOM)=LM
	DO 70 I=0,NRAD(ISORT)
	IF(ISCF.EQ.2)FUN(I,ISYM,IATOM)=(F(I,1)+F(I,NSPIN))/2.D0*NSPIN
	IF(ISCF.EQ.3)FUN(I,ISYM,IATOM)=(F(I,1)-F(I,NSPIN))
  70    CONTINUE
 100    CONTINUE
C CORE INFORMATION
	READ(1)
	READ(1)
	READ(1)
	READ(1)
	READ(1)((FUNC(I,ISPIN),I=0,NRAD(ISORT)),ISPIN=1,NSPIN)
	READ(1)
	DO 105 I=0,NRAD(ISORT)
	IF(ISCF.EQ.2)FUN(I,1,IATOM)=FUN(I,1,IATOM)-
     &  (FUNC(I,1)+FUNC(I,NSPIN))/2.D0*DBLE(NSPIN)
 105    CONTINUE
 110    CONTINUE
	CLOSE(1)
	ENDIF
	DO 220 IATOM=1,NATOM
	DO 200 LM=1,(ILS(IS(IATOM))+1)**2
	SYM(LM,IATOM)=.FALSE.
	LMSYM(LM,IATOM)=0
 200    CONTINUE
	DO 210 LM=1,(ILS(IS(IATOM))+1)**2
	DO 210 ISYM=1,NSYM(IATOM)
	IF(LMS(ISYM,IATOM).EQ.LM)SYM(LM,IATOM)=.TRUE.
	IF(LMS(ISYM,IATOM).EQ.LM)LMSYM(LM,IATOM)=ISYM
 210    CONTINUE
 220    CONTINUE
	END





	SUBROUTINE READSTR(STRFILE)
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        CHARACTER STRFILE*60,TXT*72,STRING(80)*1
        INTEGER IS(NPAT),ILS(NSORTMAX)
        DIMENSION RBASR(3,3),TAUR(3,NPAT),BASR(3),BBASR(3,3),ORTH(2:3)
     &    ,GBAS(3,3),RBAS(3,3),BBAS(3,3),TAU(3,NPAT),STRAIN(3,3,2)
     &    ,RSTN(3,3),TAU0(3,NPAT),TAU0R(3,NPAT)
        COMMON /LATTICE/RBAS,GBAS                       !!! from init
        COMMON /MANSTR/ ISTRAIN,IBAS,IBZ,ICALC          !!! from init
        COMMON /BASIS/  TAU                             !!! from init
        COMMON /BASIS0/ TAU0                            !!! from init
        COMMON /PARAM/  NSORT,IS,ILS,NATOM              !!! from init
        COMMON /LATPAR/ PAR,ORTH,OMEGAC,STRAIN          !!! from init
        COMMON /UNIT/   IUN                             !!! from init
        DATA PI/3.141592653589793D0/
        OPEN(UNIT=1,FILE=STRFILE,STATUS='OLD')
        READ(1,*)
        READ(1,1001)TXT
        READ(1,*) NATOM0,ORTH
        READ(1,*) IBAS,IBZ,ICALC,ISTRAIN
        READ(1,*) NDIV1,NDIV2
        READ(1,*) NVECMX,ALPHA
        IF(NATOM0.NE.NATOM)STOP'<READSTR>: # OF ATOMS MISMATCHES
     &  IN STRFILE, CHECK IT'
        READ(1,1000)TXT
        DO 10 IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(RBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,RBASR(1,IVEC),3)
        ENDIF
  10    CONTINUE
        READ(1,1000)TXT
        DO 15 IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAU0R(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAU0R(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAU0R(1,IATOM)=BASR(1)*RBASR(1,1)
     &                +BASR(2)*RBASR(1,2)
     &                +BASR(3)*RBASR(1,3)
        TAU0R(2,IATOM)=BASR(1)*RBASR(2,1)
     &                +BASR(2)*RBASR(2,2)
     &                +BASR(3)*RBASR(2,3)
        TAU0R(3,IATOM)=BASR(1)*RBASR(3,1)
     &                +BASR(2)*RBASR(3,2)
     &                +BASR(3)*RBASR(3,3)
        ENDIF
  15    CONTINUE
        READ(1,1000)TXT
        DO 20 IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAUR(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAUR(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAUR(1,IATOM)=BASR(1)*RBASR(1,1)
     &               +BASR(2)*RBASR(1,2)
     &               +BASR(3)*RBASR(1,3)
        TAUR(2,IATOM)=BASR(1)*RBASR(2,1)
     &               +BASR(2)*RBASR(2,2)
     &               +BASR(3)*RBASR(2,3)
        TAUR(3,IATOM)=BASR(1)*RBASR(3,1)
     &               +BASR(2)*RBASR(3,2)
     &               +BASR(3)*RBASR(3,3)
        ENDIF
  20    CONTINUE
        READ(1,1000)TXT
        DO 30 I=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(STRAIN(I,J,1),J=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        STRAIN(I,1,1)=BASR(1)
        STRAIN(I,2,1)=BASR(2)
        STRAIN(I,3,1)=BASR(3)
        ENDIF
  30    CONTINUE
C  SET RECIPROCAL STRAIN MATRIX: S*S^(-1)=1
        CALL CROSS(RSTN(1,1),STRAIN(1,2,1),STRAIN(1,3,1))
        CALL CROSS(RSTN(1,2),STRAIN(1,3,1),STRAIN(1,1,1))
        CALL CROSS(RSTN(1,3),STRAIN(1,1,1),STRAIN(1,2,1))
        W=STRAIN(1,1,1)*RSTN(1,1)
     &   +STRAIN(2,1,1)*RSTN(2,1)
     &   +STRAIN(3,1,1)*RSTN(3,1)
        IF(ABS(W).LE.1.D-10)STOP'<READSTR>:: WRONG STRAIN, DET=0'
        DO 40 I=1,3
        STRAIN(1,I,2)=RSTN(I,1)/W
        STRAIN(2,I,2)=RSTN(I,2)/W
        STRAIN(3,I,2)=RSTN(I,3)/W
  40    CONTINUE
        READ(1,*)
        READ(1,*)
        READ(1,1000)TXT
        DO 50 IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(BBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BBASR(1,IVEC),3)
        ENDIF
  50    CONTINUE
C  ACCOUNT FOR ORTHOROMBICITY PARAMETERS
        DO 90 I=2,3
        DO 70 IVEC=1,3
        RBASR(I,IVEC)=RBASR(I,IVEC)*ORTH(I)
        BBASR(I,IVEC)=BBASR(I,IVEC)/ORTH(I)
  70    CONTINUE
        DO 80 IATOM=1,NATOM
        TAU0R(I,IATOM)=TAU0R(I,IATOM)*ORTH(I)
        TAU R(I,IATOM)=TAU R(I,IATOM)*ORTH(I)
  80    CONTINUE
  90    CONTINUE
C  APPLY STRAIN MATRIX FOR TRANSLATIONS:  R'=S*R
        DO 150 IVEC=1,3
        DO 150 I=1,3
        RBAS(I,IVEC)=0.D0
        DO 140 J=1,3
        RBAS(I,IVEC)=RBAS(I,IVEC)+STRAIN(I,J,1)*RBASR(J,IVEC)
 140    CONTINUE
 150    CONTINUE
C  APPLY STRAIN FOR BASIS VECTORS:  T'=S*T
        DO 170 IATOM=1,NATOM
        DO 170 I=1,3
        TAU (I,IATOM)=0.D0
        TAU0(I,IATOM)=0.D0
        DO 160 J=1,3
        TAU (I,IATOM)=TAU (I,IATOM)+STRAIN(I,J,1)*TAU R(J,IATOM)
        TAU0(I,IATOM)=TAU0(I,IATOM)+STRAIN(I,J,1)*TAU0R(J,IATOM)
 160    CONTINUE
 170    CONTINUE
C  APPLY INVERSE STRAIN FOR BRILLOUIN ZONE: BZ'=BZ*S^(-1)
        DO 190 IVEC=1,3
        DO 190 I=1,3
        BBAS(I,IVEC)=0.D0
        DO 180 J=1,3
        BBAS(I,IVEC)=BBAS(I,IVEC)+BBASR(J,IVEC)*STRAIN(J,I,2)
 180    CONTINUE
 190    CONTINUE
C  SET RECIPROCAL LATTICE VECTORS WITHOUT 2*PI
        CALL CROSS(GBAS(1,1),RBAS(1,2),RBAS(1,3))
        CALL CROSS(GBAS(1,2),RBAS(1,3),RBAS(1,1))
        CALL CROSS(GBAS(1,3),RBAS(1,1),RBAS(1,2))
        W=RBAS(1,1)*GBAS(1,1)
     &   +RBAS(2,1)*GBAS(2,1)
     &   +RBAS(3,1)*GBAS(3,1)
        DO 230 I=1,3
        GBAS(I,1)=GBAS(I,1)/W
        GBAS(I,2)=GBAS(I,2)/W
        GBAS(I,3)=GBAS(I,3)/W
 230    CONTINUE
        OMEGAC=ABS(W)*PAR**3
C  SET BRILLOUIN ZONE TO GBAS IF REQUIRED
        IF(IBZ.EQ.1)THEN
        DO 240 I=1,3
        BBAS(I,1)=GBAS(I,1)
        BBAS(I,2)=GBAS(I,2)
        BBAS(I,3)=GBAS(I,3)
 240    CONTINUE
        ENDIF
1000    FORMAT(A)
1001    FORMAT(/A)
1010    FORMAT(2(1X,A1))
1020    FORMAT(80A1)
	END




	SUBROUTINE CROSS(A,B,C)
**********************************************************
*    Cross product (AX,AY,AZ)=(BX,BY,BZ)*(CX,CY,CZ)      *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION A(3),B(3),C(3)
	A(1)=B(2)*C(3)-B(3)*C(2)
	A(2)=B(3)*C(1)-B(1)*C(3)
	A(3)=B(1)*C(2)-B(2)*C(1)
	END
	
	
	
