	SUBROUTINE GAROOT(A,B,ROOT)
*****************************************************
*  Finds largest root for x^2=b*ln(x)-a when x>0.   *
*****************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DATA ACCU/1.D-10/
	XMAX=20.D0
  10    VAL=A-B*LOG(XMAX)+XMAX**2
	IF(VAL.LT.0.D0)XMAX=XMAX*2.D0
	IF(VAL.LT.0.D0)GOTO10
	DO 20 X=XMAX,0.D0,-0.01D0
	IF(X.EQ.0.D0)STOP' NO ROOT FOUND IN <GAROOT>'
	VALL=A-B*LOG(X)+X**2
	IF(VALL.LT.0.D0)XLEFT=X
	IF(VALL.LT.0.D0)GOTO30
	XRIGHT=X
	VALR=VALL
  20    CONTINUE
C ROOT IS LOCATED, FIND IT
  30    XROOT=(VALL*XRIGHT-VALR*XLEFT)/(VALL-VALR)
	VAL=A-B*LOG(XROOT)+XROOT**2
C Check out for exit
	IF(ABS(VAL).LE.ACCU)THEN
	ROOT=XROOT
	RETURN
	ENDIF
C Root from the right
	IF(VAL.LT.0.D0)THEN
	XLEFT=XROOT
	VALL=VAL
C Root from the left
	ELSEIF(VAL.GT.0.D0)THEN
	XRIGHT=XROOT
	VALR=VAL
	ENDIF
	GOTO 30
	END


	SUBROUTINE GAROOT1(RTOG,CUT,S,L1,L2,ROOT)
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DATA ACCU/1.D-10/
	XMAX=20.D0
  10    VAL=LOG(RTOG)+DBLE(L2)*LOG(CUT/2.D0/XMAX)-
     &  (CUT/2.D0/XMAX)**2-DBLE(L1)*LOG(S*XMAX)+(S*XMAX)**2
	IF(VAL.LT.0.D0)XMAX=XMAX*2.D0
	IF(VAL.LT.0.D0)GOTO10
	DO 20 X=XMAX,ACCU,-0.01D0
	VALL=LOG(RTOG)+DBLE(L2)*LOG(CUT/2.D0/X)-
     &  (CUT/2.D0/X)**2-DBLE(L1)*LOG(S*X)+(S*X)**2
	IF(VALL.LT.0.D0)XLEFT=X
	IF(VALL.LT.0.D0)GOTO30
	XRIGHT=X
	VALR=VALL
  20    CONTINUE
	STOP' NO ROOT FOUND IN <GAROOT>'
C ROOT IS LOCATED, FIND IT
  30    XROOT=(VALL*XRIGHT-VALR*XLEFT)/(VALL-VALR)
	VAL=LOG(RTOG)+DBLE(L2)*LOG(CUT/2.D0/XROOT)-
     &  (CUT/2.D0/XROOT)**2-DBLE(L1)*LOG(S*XROOT)+(S*XROOT)**2
C Check out for exit
	IF(ABS(VAL).LE.ACCU)THEN
	ROOT=XROOT
	RETURN
	ENDIF
C Root from the right
	IF(VAL.LT.0.D0)THEN
	XLEFT=XROOT
	VALL=VAL
C Root from the left
	ELSEIF(VAL.GT.0.D0)THEN
	XRIGHT=XROOT
	VALR=VAL
	ENDIF
	GOTO 30
	END

