	SUBROUTINE SCELLS
**************************************************************
*  Find atomic cell enevelopes and store them. (Not used!)   *
*  After Dima.Yu.Savrasov (P.N.Lebedev PhysicaL Institute)   *
*  Last revision: 02.12.92.                                  *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NTRMAX=NENVMAX)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NRAD(NSORTMAX),MDIV(3),LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NTR(NENVMAX),IREFAT(0:NVCMAX),LISTTR(3,NTRMAX,NENVMAX)
     &   ,NKAP(NPANMAX)
	DIMENSION WR(NPAT),RMT(NPAT),POLIST(3,NVCMAX),SASA(NSORTMAX)
     &   ,WS(NVCMAX),POLI(3,NVCMAX),Z(NSORTMAX),RBAS(3,3),RMT0(NPAT)
     &   ,TAU(3,NPAT),TAU0(3,NPAT),TAU00(3,NPAT),ZCOR(NSORTMAX)
     &   ,SMT(NSORTMAX),AD(3,3),RD(3,3),CUTG(0:LMAXB)
     &   ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
	COMPLEX*16 RHAN(0:LMAXB),HAN(3,0:LMAXB),EK(NKAPMAX,NPANMAX)
     &   ,EKAP(NKAPMAX,NPANMAX),ERFR(-1:LMAXB),ERFG(-1:LMAXB)
     &   ,ERF0(-1:LMAXB)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX),TPAN
	CHARACTER TXTEL(NSORTMAX)*10,SCRFILE(100)*60,BAS(0:3)*1
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /LATTICE/RBAS                                !!! from init
	COMMON /BASIS/  TAU                                 !!! from init
        COMMON /BASIS0/ TAU0                                !!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /FFTMESH/MDIV,AD,RD                          !!! from fftmsh
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                   !!! from init
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                   !!! from plwmsh
	COMMON /LATPAR/ PAR                                 !!! from init
	COMMON /OUT0/   SCRFILE                             !!! from init 
	COMMON /STORE1/ NP0,POLIST,NTR,LISTTR               !!! from polidet
	COMMON /SRFINP/ NDIV1,NDIV2                         !!! from init
	COMMON /ASASPH/ SASA                                !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN                         !!! from init
	COMMON /MULTRO/ Z,ZCOR                              !!! from init
	COMMON /RADMESH/NRAD                                !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /WORD/   NVAL                                !!! from block
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/,BAS/'s','p','d','f'/
C  OPEN SCRATCH FILE
	OPEN(UNIT=9,FILE=SCRFILE(9),STATUS='NEW',FORM='UNFORMATTED')
C  FIND EXACT MT-SPHERES FOR THIS GEOMETRY
	DO 10 IATOM=1,NATOM
	WR(IATOM)=SASA(IS(IATOM))
  10    CONTINUE
        CALL NASOS(WR,RMT ,RBAS(1,1),RBAS(1,2),RBAS(1,3),TAU ,NATOM)
        CALL NASOS(WR,RMT0,RBAS(1,1),RBAS(1,2),RBAS(1,3),TAU0,NATOM)
C ***** DO GLOBALLY OVER ALL ATOMS IN CELL *****
	DO 50 IATOM=1,NATOM                   !!! over atoms
	ISORT=IS(IATOM)
C SET UP ATOMIC CELL ENVELOPES AND STORE THEM
	IF(NDIV1.GT.0)THEN
	CALL POLISRCH(RMT0,IATOM,NDIV1,NPL,RMIN,RMAX,VOL,RV,
     &  POLI,WS,IREFAT)     
	IF(NPL.GT.NENVMAX)STOP'<SCELLS>: NENVMAX MUST BE INCREASED
     &  IN PARAM.DAT'
	ASAS=(3.D0/4.D0/PI*VOL)**(1.D0/3.D0)*PAR
	WRITE(9) (TAU(K,IATOM),K=1,3)
	WRITE(9) RMIN,RMAX,RMT(IATOM),RV,VOL
	WRITE(9) NP0,((POLIST(K,I),K=1,3),I=1,NP0)
	WRITE(9) NPL,(NTR(I),I=1,NPL)
	WRITE(9) (((LISTTR(K,I,J),K=1,3),I=1,NTR(J)),J=1,NPL)
	WRITE(9) ((POLI(K,I),K=1,3),I=1,NPL)
	WRITE(9) (WS(I),I=1,NPL),(IREFAT(I),I=0,NPL)
	ENDIF
C PRINT SPHERE RADII AND OTHER DATA
	WRITE(IUN,1010)(TAU(I,IATOM),I=1,3),TXTEL(ISORT)
	DO 40 IPAN=1,NPAN
	DO 30 IKAP=1,NKAP(IPAN)
	TPAN=.FALSE.
	DO 15 L=0,ILSB(ISORT)
	CUTG(L)=CUT(L,ISORT,IKAP,IPAN)
	IF(LSPAN(L,ISORT,IKAP,IPAN))TPAN=.TRUE.
	CALL SERFL2(ERF0,L,ETA(L,ISORT,IKAP,IPAN),
     &  SMT(ISORT),EKAP(IKAP,IPAN))
	ERFR(L)=ERF0(L)
	CALL SERFL3(ERF0,L,ETA(L,ISORT,IKAP,IPAN),
     &  SMT(ISORT),EKAP(IKAP,IPAN),CUTG(L))
	ERFG(L)=ERF0(L)
  15    CONTINUE
	IF(TPAN)WRITE(IUN,1020)DREAL(EKAP(IKAP,IPAN)),IPAN
	CALL REGHAN(SMT(ISORT),EKAP(IKAP,IPAN),SMT(ISORT),
     &  ETA(0,ISORT,IKAP,IPAN),RHAN(0),ILSB(ISORT))
	CALL HANKEL(SMT(ISORT),EKAP(IKAP,IPAN),SMT(ISORT),
     &  HAN(1,0),ILSB(ISORT))
	DO 20 L=0,ILSB(ISORT)                 !!! over l
	IF(.NOT.LSPAN(L,ISORT,IKAP,IPAN))GOTO20
	NG=LBAS(L,ISORT,IKAP,IPAN)
	CUTE=CUTG(L)**2                         ! Ry
	SCRG=0.5D0*CUTG(L)/ETA(L,ISORT,IKAP,IPAN)*2.D0*PI/PAR
	SCRR=ETA(L,ISORT,1,1)*SMT(ISORT)
	ACCR=SCRR**(L+2)*EXP(-SCRR**2)
	ACCG=SCRG**(L+0)*EXP(-SCRG**2)
	IF(L.LE.3)WRITE(IUN,1030)BAS(L),NG,CUTE,ABS(RHAN(L)/HAN(1,L)),
     &  ABS(ERFG(L)/ERFR(L))
  20    CONTINUE                              !!! over l
  30    CONTINUE
  40    CONTINUE
	NZ=Z(ISORT)
	NZCOR=ZCOR(ISORT)
	WRITE(IUN,1040)SMT(ISORT),SASA(ISORT)
	IF(NDIV1.GT.0)WRITE(IUN,1050)RMIN*PAR,ASAS
	WRITE(IUN,1060)RMT(IATOM)*PAR,NRAD(ISORT),NZ,NZCOR
        IF(RMT(IATOM)*PAR.LT.SMT(ISORT))
     &  PRINT*,'MT-SPHERES OVERLAP!!!'
        IF(RMT(IATOM)*PAR.LT.SMT(ISORT))
     &  WRITE(IUN,*)'MT-SPHERES OVERLAP!!!'
	IF(NDIV1.GT.0)WRITE(IUN,1070)RMAX*PAR,NPL
  50    CONTINUE                              !!! over atoms
	CLOSE(UNIT=9)
1010  FORMAT(1X,'Position : (',G12.5,',',G12.5,',',G12.5,') ',A10)
1020  FORMAT(1X,'Basis  Nplw   Ecut (Ry)   RH(S)/H(S) ',
     &  '   GH(S)/RH(S); Ekap=',G10.3, '; p#',I1)
1030  FORMAT(1X,1X,'"',A1,'"',2X,I5,2X,G10.3,2X,G12.5,2X,G12.5)
1040  FORMAT(1X,'input mt-sphere is ',G14.7,' ; input as-sphere is ',
     &  G14.7)
1050  FORMAT(1X,'cell  mt-sphere is ',G14.7,' ; cell  as-sphere is ',
     &  G14.7)
1060  FORMAT(1X,'touch.mt-sphere is ',G14.7,' ; nrad=',I3,',znuc=',
     &  I3,',zcor=',I3)
1070  FORMAT(1X,'circums. sphere is ',G14.7,' ; npln=',I3)
	END
