	SUBROUTINE LMTVAR(IPNT,IPAN)
*****************************************************
*  Contribution to the Pulay force going from the   *
*  change in the hamiltonian and overlap matrix     *
*  connected with the change in the structure con-  *
*  stants.                                          *
*  Written by S.Yu.Savrasov in Max-Planck-Institute.*
*****************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX),IS(NPAT)
     &    ,NKAP(NPANMAX),IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX),NPNT(NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,OPARHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,OPARJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,OPARHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,OPARJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &    ,PILF(-1:1,NPAT,NSPINMAX,NDIMMAX*NSPINMAX,2)
     &    ,PFVAL(-1:1,NPAT,NPANMAX,NSPINMAX,2)
     &    ,BHHF(-1:1,NPAT,NSPINMAX,NDIMMAX)
     &    ,BOOF(-1:1,NPAT,NSPINMAX,NDIMMAX)
	COMPLEX*16 DSDOTNUC(-1:1),DSKLDNUC(-1:1),CHDOT,CODOT
     &    ,CCHJH,CCHHJ,CCHJJ1,CCHJJ2,CCOJH,CCOHJ,CCOJJ1,CCOJJ2
     &    ,CGNT(LIMLMT,NPAT,-1:1,2),CONVHHM,CONVOOM,CONVOOP,CONVHHP
     &    ,HPARHH(LIMLMB,LIMLMB,NKAPMAX,NKAPMAX)
     &    ,HPARJH(LIMLMT,LIMLMB,NKAPMAX,NKAPMAX)
     &    ,HPARHJ(LIMLMB,LIMLMT,NKAPMAX,NKAPMAX)
     &    ,HPARJJ(LIMLMT,LIMLMT,NKAPMAX,NKAPMAX)
     &    ,SS(LIMLMT1,NPAT,LIMLMB,NPAT,NKAPMAX)
     &    ,SSDOT(LIMLMB1,NPAT,LIMLMB,NPAT,NKAPMAX)
	COMPLEX*16 AKL(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NDIMMAX)
     &    ,SPARHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,SPARJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,SPARHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,SPARJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &    ,SKL(LIMLMT1,NKAPMAX,NSPINMAX),SKLDOT
     &    ,DSKLDOT(LIMLMB1,NKAPMAX,NPAT)
     &    ,DSKL(LIMLMT1,NKAPMAX,NPAT)
	DIMENSION C(0:LMAXV+1,LMMAXV1,LMMAXV1),SLM(LIMLMT,2)
     &    ,EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX),SMT(NSORTMAX)
     &    ,GGNT(0:LMAXV+1,0:LMAXV+1,0:LMAXV+1)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /CONTROL/MAN,LMTO,NLR,NINT,NPF                 !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM         !!! from init
	COMMON /POTCOM/ SWZ,SMT                               !!! from init
	COMMON /DENS/   SS,SSDOT                              !!! from strgnt
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                     !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                 !!! from init
	COMMON /STORE1/ HPARHH,HPARJH,HPARHJ,HPARJJ           !!! from lmtpar
	COMMON /OVRPAR/ OPARHH,OPARJH,OPARHJ,OPARJJ           !!! from lmtpar
        COMMON /ORBPAR/ SPARHH,SPARJH,SPARHJ,SPARJJ           !!! from orbpar
	COMMON /STORE2/ AKL,SKL,DSKL,DSKLDOT                  !!! tmp.storage
	COMMON /LATPAR/ PAR                                   !!! from init
	COMMON /ENERGY/ EARR                                  !!! from lmtbnd
	COMMON /GAUNT/  C,GGNT                                !!! from gdata
	COMMON /PILAUF/ PFVAL,PILF                            !!! from lmtvar
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                     !!! from init
	COMMON /MESH/   NPNT                                  !!! from bzmesh
	COMMON /ORBS/   NORBS                                 !!! from init
	COMMON /SPIN/   NSPIN                                 !!! from init
	COMMON /UNIT/   IUN                                   !!! from init
	COMMON /WORD/   NVAL                                  !!! from nmtdata
	SAVE CGNT,SLM
	DATA PI/3.141592653589793D0/
	IF(NPF.EQ.0)RETURN
	SQPI43=SQRT(4.D0*PI/3.D0)
	IF(IPNT.EQ.1)THEN
C  CALCULATE GAUNT-COEFFICIENT-COMBINATION ARRAY
	DO IATOM=1,NATOM                               !!! over atoms
	ISORT=IS(IATOM) 
	DO MY=-1,1                                     !!! over my
	DO L=0,ILST(ISORT)                             !!! over l
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	LM1MY=(L-1)*L+M-MY+1
	LP1MY=(L+1)*(L+2)+M-MY+1
	CG1=0.D0
	IF(L.NE.0.AND.ABS(M-MY).LE.L-1)
     &  CG1=C(0,LM,LM1MY)*SQPI43/(2.D0*L-1.D0)*SMT(ISORT)
	CG2=C(0,LM,LP1MY)*SQPI43*(2.D0*L+1.D0)/SMT(ISORT)
	CGNT(LM,IATOM,MY,1)=(0.D0,1.D0)*CG1
	CGNT(LM,IATOM,MY,2)=(0.D0,1.D0)*CG2
        ENDDO                                          !!! over m
        ENDDO                                          !!! over l
        ENDDO                                          !!! over my
        ENDDO                                          !!! over atoms
C  SET <Ylm|s*l|Ylm>/2 MATRIX ELEMENT
        DO L=0,LMAXT
        DO M=-L,L
        LM=L*(L+1)+M+1
        SLM(LM,1)=0.5D0*SQRT(DBLE((L-M)*(L+M+1)))
        SLM(LM,2)=0.5D0*SQRT(DBLE((L+M)*(L-M+1)))
        ENDDO
        ENDDO
	ENDIF
C  *** DO GLOBALLY OVER SPIN SUBBANDS ***
        DO 4000 IBNDS=1,NSPIN                          !!! over spin subbands
C  READ EXPANSION COEFFICIENTS FOR OCCUPIED BANDS
        DO IORBS=1,NORBS                               !!! over spinor components
	DO IBNDT=1,NBNDF(IPAN)                         !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IKAP=1,NKAP(IPAN)                           !!! over energies
        IREC=IKAP+NKAP(IPAN)*(IBNDT-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(IORBS-1)
	READ(14,REC=IREC)((AKL(LM,IATOM,IKAP,IORBS,IBNDT),
     &  LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM)
	ENDDO                                          !!! over energies
	ENDDO                                          !!! over bands
	ENDDO                                          !!! over spinor components
C  SET CONTRIBUTION FROM H- AND MATRICES TO ZERO
        DO IORBS=1,NSPIN                               !!! over spinor components
	DO IBNDT=1,NBNDF(IPAN)                         !!! over bands
	DO INUC=1,NATOM                                !!! over displacements
	DO MY=-1,1                                     !!! over polarizations
	BHHF(MY,INUC,IORBS,IBNDT)=(0.D0,0.D0)
	BOOF(MY,INUC,IORBS,IBNDT)=(0.D0,0.D0)
        ENDDO                                          !!! over polarizations
        ENDDO                                          !!! over displacements
        ENDDO                                          !!! over bands
	ENDDO                                          !!! over spinor components
C  DO GLOBALLY OVER SPINOR COMPONENTS AND ATOMS
	DO 3000 IORBS=1,NORBS                          !!! over spinor components
        IF(NORBS.EQ.1)ISPIN=IBNDS
        IF(NORBS.EQ.2)ISPIN=IORBS
	DO 2000 IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
C  READ POTENTIAL PARAMETERS    
	DO IKAP1=1,NKAP(IPAN)                          !!! over energies
	DO IKAP =1,NKAP(IPAN)                          !!! over energies
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NKAP(IPAN)**2*NATOM*(ISPIN-1)
	READ(13,REC=IREC)((HPARHH(L1M1,LM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARJH(L1M1,LM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARHJ(L1M1,LM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((HPARJJ(L1M1,LM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
        ENDDO                                          !!! over energies
        ENDDO                                          !!! over energies
C  **** DO GLOBALLY OVER VALENCE BANDS ****
	DO 1000 IBNDT=1,NBNDF(IPAN)                    !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
C  CALCULATE CHANGE IN THE STRUCTURE CONSTANTS
	DO IKAP=1,NKAP(IPAN)                           !!! over energies
	DO L=0,ILST(ISORT)+1                           !!! over l
	LOG=.FALSE.
	IF(L.LE.ILSB(ISORT)+1)LOG=.TRUE.
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	DO IORBS1=1,NORBS
	SKL(LM,IKAP,IORBS1)=(0.D0,0.D0) 
	ENDDO
	SKLDOT=(0.D0,0.D0)
	DO IATOM1=1,NATOM                              !!! over atoms
	ISORT1=IS(IATOM1)
	DSKL(LM,IKAP,IATOM1)=(0.D0,0.D0)
	IF(LOG)DSKLDOT(LM,IKAP,IATOM1)=(0.D0,0.D0)
	DO L1=0,ILSB(ISORT1)                           !!! over l1
	IF(LTPAN(L1,IATOM1,IKAP,IPAN))THEN
	DO M1=-L1,L1                                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO IORBS1=1,NORBS
	SKL(LM,IKAP,IORBS1)=SKL(LM,IKAP,IORBS1)+
     &  SS(LM,IATOM,L1M1,IATOM1,IKAP)*AKL(L1M1,IATOM1,IKAP,IORBS1,IBNDT)
	ENDDO
	DSKL(LM,IKAP,IATOM1)=DSKL(LM,IKAP,IATOM1)-
     &  SS(LM,IATOM,L1M1,IATOM1,IKAP)*AKL(L1M1,IATOM1,IKAP,IORBS,IBNDT)
	IF(LOG)DSKLDOT(LM,IKAP,IATOM1)=DSKLDOT(LM,IKAP,IATOM1)-
     &  SSDOT(LM,IATOM,L1M1,IATOM1,IKAP)*
     &  AKL(L1M1,IATOM1,IKAP,IORBS,IBNDT)
        ENDDO                                          !!! over m1
	ENDIF
        ENDDO                                          !!! over l1
	IF(LOG)SKLDOT=SKLDOT-DSKLDOT(LM,IKAP,IATOM1)
        ENDDO                                          !!! over atoms
	DSKL(LM,IKAP,IATOM)=DSKL(LM,IKAP,IATOM)+SKL(LM,IKAP,IORBS)
	IF(LOG)DSKLDOT(LM,IKAP,IATOM)=DSKLDOT(LM,IKAP,IATOM)+SKLDOT
        ENDDO                                          !!! over m
        ENDDO                                          !!! over l
        ENDDO                                          !!! over energies
C  **** DO GLOBALLY OVER LM,IKAP ****
	DO IKAP=1,NKAP(IPAN)                           !!! over energies
	DO L=0,ILST(ISORT)                             !!! over l
	LOG=.FALSE.
	IF(L.LE.ILSB(ISORT))LOG=.TRUE.
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
C  CALCULATE CONVOLUTION WITH THE POTENTIAL PARAMETERS
	CCHJH =(0.D0,0.D0)
	CCHHJ =(0.D0,0.D0)
	CCHJJ1=(0.D0,0.D0)
	CCHJJ2=(0.D0,0.D0)
	CCOJH =(0.D0,0.D0)
	CCOHJ =(0.D0,0.D0)
	CCOJJ1=(0.D0,0.D0)
	CCOJJ2=(0.D0,0.D0)
	DO IKAP1=1,NKAP(IPAN)                          !!! over energies
C  Hamiltonian parameters
	DO L1=0,ILST(ISORT)                            !!! over l1
	DO M1=-L1,L1                                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))
     &  CCHJH=CCHJH+HPARJH(LM,L1M1,IKAP,IKAP1)*
     &  AKL(L1M1,IATOM,IKAP1,IORBS,IBNDT)
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))
     &  CCHHJ=CCHHJ+CONJG(HPARHJ(L1M1,LM,IKAP1,IKAP))*
     &  AKL(L1M1,IATOM,IKAP1,IORBS,IBNDT)
	CCHJJ1=CCHJJ1+HPARJJ(LM,L1M1,IKAP,IKAP1)*
     &  SKL(L1M1,IKAP1,IORBS)
        CCHJJ2=CCHJJ2+CONJG(HPARJJ(L1M1,LM,IKAP1,IKAP))*
     &  SKL(L1M1,IKAP1,IORBS)
        ENDDO                                          !!! over m1
        ENDDO                                          !!! over l1
C  Spin-orbit block
        IF(NORBS.EQ.2)THEN
	IF(IORBS.EQ.1)ISIGN=1
	IF(IORBS.EQ.1)IORBS1=NORBS
	IF(IORBS.EQ.NORBS)ISIGN=-1
	IF(IORBS.EQ.NORBS)IORBS1=1
	M1=M-ISIGN
        LM1=L*(L+1)+M1+1
        IF(LTPAN(L,IATOM,IKAP1,IPAN).AND.ABS(M1).LE.L)
     &  CCHJH=CCHJH+SPARJH(IKAP,IKAP1,L,ISORT,IORBS1)*
     &  SLM(LM1,IORBS1)*AKL(LM1,IATOM,IKAP1,IORBS1,IBNDT)
	M1=M+ISIGN
        LM1=L*(L+1)+M1+1
        IF(LTPAN(L,IATOM,IKAP1,IPAN).AND.ABS(M1).LE.L)
     &  CCHHJ=CCHHJ+CONJG(SPARHJ(IKAP1,IKAP,L,ISORT,IORBS))*
     &  SLM(LM,IORBS)*AKL(LM1,IATOM,IKAP1,IORBS1,IBNDT)
	M1=M-ISIGN
        LM1=L*(L+1)+M1+1
	IF(ABS(M1).LE.L)
     &  CCHJJ1=CCHJJ1+SPARJJ(IKAP,IKAP1,L,ISORT,IORBS1)*
     &  SLM(LM1,IORBS1)*SKL(LM1,IKAP1,IORBS1)
	M1=M+ISIGN
        LM1=L*(L+1)+M1+1
        IF(ABS(M1).LE.L)
     &  CCHJJ2=CCHJJ2+CONJG(SPARJJ(IKAP1,IKAP,L,ISORT,IORBS))*
     &  SLM(LM,IORBS)*SKL(LM1,IKAP1,IORBS1)
        ENDIF
C  Overlap parameters
	IF(LTPAN(L,IATOM,IKAP1,IPAN))
     &  CCOJH=CCOJH+OPARJH(IKAP,IKAP1,L,ISORT,ISPIN)*
     &  AKL(LM,IATOM,IKAP1,IORBS,IBNDT)
	IF(LTPAN(L,IATOM,IKAP1,IPAN))
     &  CCOHJ=CCOHJ+CONJG(OPARHJ(IKAP1,IKAP,L,ISORT,ISPIN))*
     &  AKL(LM,IATOM,IKAP1,IORBS,IBNDT)
	CCOJJ1=CCOJJ1+OPARJJ(IKAP,IKAP1,L,ISORT,ISPIN)*
     &  SKL(LM,IKAP1,IORBS)
        CCOJJ2=CCOJJ2+CONJG(OPARJJ(IKAP1,IKAP,L,ISORT,ISPIN))*
     &  SKL(LM,IKAP1,IORBS)
        ENDDO                                          !!! over energies
C  S-dot parameters
	CHDOT=(0.D0,0.D0)
	CODOT=(0.D0,0.D0)
	IF(LTPAN(L,IATOM,IKAP,IPAN).AND.EKAP(IKAP,IPAN).EQ.
     &  CONJG(EKAP(IKAP,IPAN)))THEN 
	CHDOT=-AKL(LM,IATOM,IKAP,IORBS,IBNDT)*EKAP(IKAP,IPAN)*PAR**3
	CODOT=-AKL(LM,IATOM,IKAP,IORBS,IBNDT)*PAR**3
	ENDIF
	CONVHHM=-CCHJH+CCHJJ1
	CONVOOM=-CCOJH+CCOJJ1
	CONVHHP=-CCHHJ+CCHJJ2
	CONVOOP=-CCOHJ+CCOJJ2
	DO INUC=1,NATOM                                !!! over displacements
	DO MY=-1,1                                     !!! over polarizations
	LM1MY=(L-1)*L+M-MY+1
	LP1MY=(L+1)*(L+2)+M-MY+1
	DSKLDNUC(MY)=CGNT(LM,IATOM,MY,2)*DSKL(LP1MY,IKAP,INUC)
	IF(L.NE.0.AND.ABS(M-MY).LE.L-1)DSKLDNUC(MY)=DSKLDNUC(MY)+
     &  CGNT(LM,IATOM,MY,1)*DSKL(LM1MY,IKAP,INUC)*EKAP(IKAP,IPAN)
	DSDOTNUC(MY)=(0.D0,0.D0)
	IF(LOG)THEN
	DSDOTNUC(MY)=CGNT(LM,IATOM,MY,2)*DSKLDOT(LP1MY,IKAP,INUC)
	IF(L.NE.0.AND.ABS(M-MY).LE.L-1)DSDOTNUC(MY)=DSDOTNUC(MY)+
     &  CGNT(LM,IATOM,MY,1)*DSKLDOT(LM1MY,IKAP,INUC)*EKAP(IKAP,IPAN)+
     &  CGNT(LM,IATOM,MY,1)*DSKL(LM1MY,IKAP,INUC)/PAR**2
	ENDIF
        ENDDO                                          !!! over polarizations
	DO MY=-1,1                                     !!! over poalrizations
	BHHF(MY,INUC,IORBS,IBNDT)=BHHF(MY,INUC,IORBS,IBNDT)+
     &  CONJG(CONVHHP)*DSKLDNUC(MY)+
     &  CONVHHM*CONJG(DSKLDNUC(-MY))*(-1)**MY+
     &  CHDOT*CONJG(DSDOTNUC(-MY))*(-1)**MY
	BOOF(MY,INUC,IORBS,IBNDT)=BOOF(MY,INUC,IORBS,IBNDT)+
     &  CONJG(CONVOOP)*DSKLDNUC(MY)+
     &  CONVOOM*CONJG(DSKLDNUC(-MY))*(-1)**MY+
     &  CODOT*CONJG(DSDOTNUC(-MY))*(-1)**MY
        ENDDO                                          !!! over polarizations
        ENDDO                                          !!! over displacements
        ENDDO                                          !!! over m
        ENDDO                                          !!! over l
        ENDDO                                          !!! over energies
1000	CONTINUE                                       !!! over bands
2000	CONTINUE                                       !!! over atoms
3000	CONTINUE                                       !!! over spinor components
C  SET PULAY FORCE
	DO IBNDT=1,NBNDF(IPAN)                         !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IORBS=1,NORBS                               !!! over spinor components
	DO INUC=1,NATOM                                !!! over displacements
	DO MY=-1,1                                     !!! over polarizations
	PILF(MY,INUC,IORBS,IBAND,1)=BHHF(MY,INUC,IORBS,IBNDT)-
     &  EARR(IBAND,IPNT,IPAN)*BOOF(MY,INUC,IORBS,IBNDT)
        ENDDO                                          !!! over polarizations
        ENDDO                                          !!! over displacements
        ENDDO                                          !!! over spinor components
        ENDDO                                          !!! over bands
4000	CONTINUE                                       !!! over spin subbands
	END
