	SUBROUTINE MIXHUB(ITER,KY)
**********************************************************
*  Mixes old and new partial occupancies.                *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NKAP(NPANMAX)
	DIMENSION SMT(NSORTMAX)
	COMPLEX*16 DHUB(LIMLMB2,NPAT,NSPINMAX),WINP(NTERMAX)
     &   ,DHUBOLD(LIMLMB2,NPAT,NSPINMAX,0:NTERMAX),AMINP,AMNEW
     &   ,WMIX(NTERMAX,NTERMAX),ROOUT,ROINP,RONEW,AMOUT
	CHARACTER*10 TXTEL(NSORTMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from readini
	COMMON /POTCOM/ SWZ,SMT                              !!! from vfull
        COMMON /MIXRHO1/ADMIX1,ADMIN,ADMAX,KEY,ADMOPT        !!! from mixro1
        COMMON /MIXMAG1/ADMSPN,ASMIN,ASMAX,KSP,ADSPIN        !!! from mixro1
        COMMON /MIXBROY/LBROY,IBROY,ADMIXB,ADMIXH,MTER,WINP,WMIX!from readini
	COMMON /KAPPAR/ NPAN,NKAP                            !!! from readini
	COMMON /HUBCOM/ DHUB                                 !!! from hubpot
        COMMON /INP1/   ICHUB                                !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
	COMMON /UNIT/   IUN                                  !!! from readini
	COMMON /TXTEL/  TXTEL                                !!! from readini
	SAVE DHUBOLD
	DATA PI/3.141592653589793D0/,ISCHEME/2/
	IF(ICHUB.EQ.0)RETURN
	IF(ISCHEME.EQ.1.OR.LBROY.LT.0)THEN 
C  DO LINEAR MIXING FOR OCCUPANCIES
	DO IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	DO K=-L,L                                 !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	IF(KY.EQ.2)THEN
        ROOUT=(DHUB(IU,IATOM,1)+DHUB(IU,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
        ROINP=(DHUBOLD(IU,IATOM,1,0)+DHUBOLD(IU,IATOM,NSPIN,0))/
     &  2.D0*DBLE(NSPIN)
        RONEW=ADMOPT*ROOUT+(1.D0-ADMOPT)*ROINP
        AMOUT=(DHUB(IU,IATOM,1)-DHUB(IU,IATOM,NSPIN))
        AMINP=(DHUBOLD(IU,IATOM,1,0)-DHUBOLD(IU,IATOM,NSPIN,0))
        AMNEW=ADSPIN*AMOUT+(1.D0-ADSPIN)*AMINP
        DHUB(IU,IATOM,1)=(RONEW+AMNEW)/DBLE(NSPIN)
        DHUB(IU,IATOM,NSPIN)=(RONEW-AMNEW)/DBLE(NSPIN)
	ENDIF
    	DO ISPIN=1,NSPIN                          !!! over spins
	DHUBOLD(IU,IATOM,ISPIN,0)=DHUB(IU,IATOM,ISPIN)
	ENDDO                                     !!! over spins
	ENDDO                                     !!! over k
	ENDDO                                     !!! over m
	ENDDO                                     !!! over l
	ENDDO                                     !!! over atoms
	ELSEIF(ISCHEME.EQ.2.AND.LBROY.GE.0)THEN 
C  DO BROYDEN MIXING FOR OCCUPANCIES
    	DO ISPIN=1,NSPIN                          !!! over spins
	DO IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	DO K=-L,L                                 !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	IF(KY.EQ.1.AND.MTER.EQ.0)
     &  DHUBOLD(IU,IATOM,ISPIN,MTER)=DHUB(IU,IATOM,ISPIN)
	IF(KY.EQ.2)THEN
        DHUBOLD(IU,IATOM,ISPIN,MTER)=DHUB(IU,IATOM,ISPIN)
	RONEW=WINP(MTER)*DHUBOLD(IU,IATOM,ISPIN,0)
	DO LTER=1,MTER                            !!! over iterations
	RONEW=RONEW+WMIX(MTER,LTER)*DHUBOLD(IU,IATOM,ISPIN,LTER)
	ENDDO                                     !!! over iterations
 	DHUB(IU,IATOM,ISPIN)=RONEW
	ENDIF
	ENDDO                                     !!! over k
	ENDDO                                     !!! over m
	ENDDO                                     !!! over l
	ENDDO                                     !!! over atoms
	ENDDO                                     !!! over spins
	ENDIF
	END

