	SUBROUTINE PULINT(IPNT,IPAN,IC)
***********************************************************
*  Calculates contribution to the Pulay force.            *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NKAP(NPANMAX),NPNT(NPANMAX),NDIV(3),NDIC(3)
        INTEGER INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3)
	COMPLEX*16 YLM(LIMLMB,0:NBASMAX),APH(LIMLMB,NPAT,NKAPMAX)
     &    ,EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX),CTMP
     &    ,CFTR(0:LMAXB,NSORTMAX,NKAPMAX,0:NBASMAX)
     &    ,PILF(-1:1,NPAT,NSPINMAX,NDIMMAX*NSPINMAX,2)
     &    ,PFVAL(-1:1,NPAT,NPANMAX,NSPINMAX,2),DPSI(0:NBASMAX)
     &    ,EXPK(0:NPLWMAX),PSIK(0:NBASMAX),EXPK0,EXPS0
     &    ,RFUN(NDIMMAX,0:MBASMAX),RINT0(NDIMMAX,NDIMMAX)
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &    ,PNTR(3),PNTK(3),PNT(3,KMAX,NPANMAX),WGT(KMAX,NPANMAX)
     &    ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),SH(3,NPANMAX)
     &    ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &    ,EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &    ,WEIGH(NDIMMAX*NSPINMAX,KMAX)
     &    ,WEIGD(NDIMMAX*NSPINMAX,KMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),EXIST
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
        CHARACTER SCRFILE(100)*60
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR,NPF                !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /BASIS/  TAU                                  !!! from init
	COMMON /POTCOM/ SWZ,SMT                              !!! from init
	COMMON /DENS/   PNTR,CFTR,YLM                        !!! from strgnt
        COMMON /STORE1/ RFUN,RINT0                           !!! from nultos
        COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from plwmsh
	COMMON /ENERGY/ EARR,WEIGH,WEIGD                     !!! from ttrint1
	COMMON /PILAUF/ PFVAL,PILF                           !!! from lmtvar
	COMMON /MESH/   NPNT,PNT,WGT                         !!! from ttrmsh
	COMMON /ORBS/   NORBS                                !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
        COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG      !!! from plwmsh
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
        COMMON /INTTR/  NDIV,NDIC,SH                         !!! from init
        COMMON /OUT0/   SCRFILE                              !!! from init
	COMMON /INDX/   IND                                  !!! from lmtpar
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
	IF(NPF.EQ.0)RETURN
C  INTEGRATE PULAY FORCE
        DO IORBS=1,NORBS                        !!! over spinor components
        DO IBNDS=1,NSPIN                        !!! over spin subbands
        IF(NORBS.EQ.1)ISPIN=IBNDS
        IF(NORBS.EQ.2)ISPIN=IORBS
        DO IBNDT=1,NBNDF(IPAN)                  !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(.NOT.(IC.EQ.0.AND.IBNDT.GE.NBNDE(IPAN)))THEN
	IF(.NOT.(IC.EQ.1.AND.IBNDT.LT.NBNDE(IPAN)))THEN
	IF(IC.EQ.0)WHT=WGT(IPNT,IPAN)/DBLE(NSPIN)
	IF(IC.EQ.1)WHT=WEIGH(IBAND,IPNT)
        IF(IC.EQ.1.AND.IBNDT.GE.NBNDE(IPAN))THEN  ! for fermi states
        IF(IPAN.GT.1)STOP'<TOSPAR> ERROR IN READ STATEMENT'
        IREC=IBNDT-NBNDE(1)+1+
     &  (NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &  (NBNDF(1)-NBNDE(1)+1)*NSPIN*(IORBS-1)+
     &  (NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
        READ(16,REC=IREC)(((PILF(MY,INUC,IORBS,IBAND,IMI),
     &  MY=-1,1),INUC=1,NATOM),IMI=1,2)
        ENDIF
	DO INUC=1,NATOM                         !!! over displacements
	DO MY=-1,1                              !!! over polarizations
	PFVAL(MY,INUC,IPAN,ISPIN,1)=PFVAL(MY,INUC,IPAN,ISPIN,1)+
     &  PILF(MY,INUC,IORBS,IBAND,1)*WHT
	PFVAL(MY,INUC,IPAN,ISPIN,2)=PFVAL(MY,INUC,IPAN,ISPIN,2)+
     &  PILF(MY,INUC,IORBS,IBAND,2)*WHT
        ENDDO                                   !!! over polarizations
        ENDDO                                   !!! over displacements
	ENDIF
	ENDIF
        ENDDO                                   !!! over bands
        ENDDO                                   !!! over spin subbands
        ENDDO                                   !!! over spinor components
	IF(KEYT.LE.0)RETURN
C  **** MAKE AUXILARY ARRAYS *****
C  FIND K-POINT PNTR=K+G WHICH HAS A MINIMAL LENGTH
        XK=PNT(1,IPNT,IPAN)+SH(1,IPAN)
        YK=PNT(2,IPNT,IPAN)+SH(2,IPAN)
        ZK=PNT(3,IPNT,IPAN)+SH(3,IPAN)
        CALL REDUC2(XK,YK,ZK,NBAS,GPLW(1,0),PNTK(1),PNTK(2),PNTK(3),
     &  GRX,GRY,GRZ)
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
        CALL FTRMAT(PNTK,0,IPAN)
C  DO OVER POLARIZATIONS
	DO 4000 IXYZ=1,3                        !!! over polarizations
C  DO GLOBALLY OVER BANDS, SPINS
        DO 3000 IORBS=1,NORBS                   !!! over spinor components
        DO 2000 IBNDS=1,NSPIN                   !!! over spin subbands
        IF(NORBS.EQ.1)ISPIN=IBNDS
        IF(NORBS.EQ.2)ISPIN=IORBS
	IREC=ISPIN+NSPIN*(IXYZ-1)
        READ(20,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
        DO 1000 IBNDT=1,NBNDF(IPAN)             !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(IC.EQ.0.AND.IBNDT.GE.NBNDE(IPAN))GOTO1000
	IF(IC.EQ.1.AND.IBNDT.LT.NBNDE(IPAN))GOTO1000
	IF(IC.EQ.0)WHT=WGT(IPNT,IPAN)/DBLE(NSPIN)
	IF(IC.EQ.1)WHT=WEIGH(IBAND,IPNT)
	DO IBAS=0,NBAS
	PSIK(IBAS)=(0.D0,0.D0)
	ENDDO
	DO IKAP=1,NKAP(IPAN)                    !!! over energies
C  READ VARIATIONAL COEFFICIENTS
        IF(IC.EQ.0)THEN !!! called from bands
        IREC=IKAP+NKAP(IPAN)*(IBNDT-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(IORBS-1)
        READ(14,REC=IREC)
     &  ((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM)
        ELSEIF(IC.EQ.1.AND.IBNDT.GE.NBNDE(IPAN))THEN !!! from ttrint
        IF(IPAN.GT.1)STOP'<LMTBND>: RECORD FOR IPAN.GT.1 NOT ALLOWED'
        IREC=IKAP+NKAP(1)*(IBNDT-NBNDE(1))+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*(IORBS-1)+
     &  NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
        READ(15,REC=IREC)
     &  ((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM)
	ENDIF
	DO IATOM=1,NATOM                        !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,MIN(NBAS,MBAS)
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
C  PSEUDOWAVEFUNCTION 
	DO L=0,ILSB(ISORT)                      !!! over l
	IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
	MINB=MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
	DO M=-L,L                               !!! over m
        LM=L*(L+1)+M+1
	DO IBAS=0,MINB
	PSIK(IBAS)=PSIK(IBAS)+APH(LM,IATOM,IKAP)*
     &  CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
        ENDDO        
        ENDDO                                   !!! over m
	ENDIF
        ENDDO                                   !!! over l
        ENDDO                                   !!! over iatom
        ENDDO                                   !!! over ikap
	DO IBAS=0,MIN(NBAS,MBAS)                !!! over ibas
	DPSI(IBAS)=DCONJG(PSIK(IBAS))*WHT
        ENDDO                                   !!! over ibas
C  AUXILARY ARRAYS: 
        DO IATOM1=1,NATOM                       !!! over iatom1
        ISORT1=IS(IATOM1)
        SCP=PNTK(1)*TAU(1,IATOM1)+
     &      PNTK(2)*TAU(2,IATOM1)+
     &      PNTK(3)*TAU(3,IATOM1)
        EXPS0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
        DO IKAP1=1,NKAP(IPAN)                   !!! over energy
        DO L1=0,ILSB(ISORT1)                    !!! over l1
        IF(LTPAN(L1,IATOM1,IKAP1,IPAN))THEN
        DO M1=-L1,L1                            !!! over m1
        L1M1=L1*(L1+1)+M1+1
        IPAR1=IND(L1M1,IATOM1,IKAP1,1,IPAN)
C  1) TOS-MATRIX
        DO IATOM=1,NATOM                        !!! over iatom
        ISORT=IS(IATOM)
        SCP=PNTK(1)*TAU(1,IATOM)+
     &      PNTK(2)*TAU(2,IATOM)+
     &      PNTK(3)*TAU(3,IATOM)
        EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
        DO IKAP=1,NKAP(IPAN)                    !!! over energy
        DO L=0,ILSB(ISORT)                      !!! over l
        IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
        DO M=-L,L                               !!! over m
        LM=L*(L+1)+M+1
        IPAR=IND(LM,IATOM,IKAP,1,IPAN)
        IF(IPAR1.GE.IPAR)
     &  RINT0(IPAR1,IPAR)=RINT0(IPAR1,IPAR)+WHT*PNTR(IXYZ)*
     &	DCONJG(APH(L1M1,IATOM1,IKAP1)*EXPS0)*APH(LM,IATOM,IKAP)*
     &  EXPK0
        ENDDO                                   !!! over m
	ENDIF
        ENDDO                                   !!! over l
        ENDDO                                   !!! over energy
        ENDDO                                   !!! over iatom
C  2) RFUN-ARARY
	DO IBAS=0,MIN(NBAS,MBAS)                !!! over ibas
	RFUN(IPAR1,IBAS)=RFUN(IPAR1,IBAS)+WHT*PNTR(IXYZ)*
     &  DCONJG(APH(L1M1,IATOM1,IKAP1)*EXPS0)*PSIK(IBAS)
        ENDDO                                   !!! over ibas
        ENDDO                                   !!! over m1
	ENDIF
        ENDDO                                   !!! over l1
        ENDDO                                   !!! over energy
        ENDDO                                   !!! over iatom1
1000    CONTINUE                                !!! over bands
	IREC=ISPIN+NSPIN*(IXYZ-1)
        WRITE(20,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
2000    CONTINUE                                !!! over spin subbands
3000    CONTINUE                                !!! over spinor components
4000	CONTINUE                                !!! over polarizations
	RETURN








        ENTRY SNULPUL(IPAN)
************************************************
*  Zeroises Puley force parameters             *
************************************************
C  OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
        INQUIRE(FILE=SCRFILE(20),EXIST=EXIST)
        IF(.NOT.EXIST)THEN
        NRECL=NVAL*(NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &  NBNDT(IPAN)**2)
        OPEN(UNIT=20,FILE=SCRFILE(20),STATUS='NEW',
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
        ENDIF
        IF(KEYT.LE.0)RETURN
        IF(NPF .EQ.0)RETURN
        DO IXYZ=1,3                                    !!! over polarizations
        DO ISPIN=1,NSPIN                               !!! over spins
        DO IDIM=1,NBNDT(IPAN)                          !!! over idim
        DO JDIM=1,NBNDT(IPAN)                          !!! over jdim
        RINT0(JDIM,IDIM)=(0.D0,0.D0)
        ENDDO                                          !!! over jdim
        DO IBAS=0,MIN(NBAS,MBAS)                       !!! over ibas
        RFUN(IDIM,IBAS)=(0.D0,0.D0)
        ENDDO                                          !!! over ibas
        ENDDO                                          !!! over idim
	IREC=ISPIN+NSPIN*(IXYZ-1)
        WRITE(20,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
        ENDDO                                          !!! over spins
        ENDDO                                          !!! over polarizations
        END

