	SUBROUTINE SPLNRO
**************************************************************
*  Spline old density into new radial mesh.                  *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	CHARACTER TXTEL(NSORTMAX)*10
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),NSYMOLD(NPAT),LMOLD(NSYMMAX,NPAT)
     &   ,NRADOLD(NSORTMAX),NRAD(NSORTMAX),ICOR(NSORTMAX)
	DIMENSION DERIN(0:NRADMAX,2),GBAS(3,3),RBASOLD(3,3)
     &   ,STRAIN(3,3,2),RBAS(3,3),GBASOLD(3,3),ORTH(2:3)
     &   ,ROLD(0:NRADMAX,NSORTMAX),WORK1(0:NRADMAX,2),ORTHOLD(2:3)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),H(NSORTMAX),HLIB(NSORTMAX)
     &   ,R(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,ROTMPR(0:NRADMAX),ROTMPI(0:NRADMAX),GPLWOLD(3,0:NPLWMAX)
     &   ,DEROUT(0:NRADMAX,2),GPLW(3,0:NPLWMAX)
     &   ,ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,RHOPS(0:NPLWMAX,NSPINMAX),OLDPS(0:NPLWMAX)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!! from init
	COMMON /DENS/    RO,ROVALDS,ROCOR                   !!! from init 
	COMMON /LATTICE/ RBAS,GBAS                          !!! from init
	COMMON /PSRHO/   RHOPS                              !!! from init
	COMMON /RADMESH/ NRAD,H,R,DR,WEIGHT                 !!! from radmsh
	COMMON /OLDMESH/ NSYMOLD,LMOLD,NRADOLD,ROLD,
     &                   NPLWOLD,GPLWOLD,ORTHOLD,GBASOLD,RBASOLD    !init
	COMMON /PLWMESH/ NPLW,GPLW                          !!! from plwmsh
	COMMON /LATPAR/  PAR,ORTH,OMEGAC,STRAIN             !!! from init
	COMMON /SPIN/    NSPIN                              !!! from init
	COMMON /TXTEL/   TXTEL                              !!! from init
	COMMON /UNIT/    IUN                                !!! from init
	DATA PI/3.141592653589793D0/
C  FULL DENSITY AND PSEUDODENSITY
	DO 110 ISPIN=1,NSPIN                     !!! over spins
	DO 100 IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
	DO 10 I=0,NRAD(ISORT)
	IF(R(I,ISORT)-ROLD(NRADOLD(ISORT),ISORT).GT.1.D-09)GOTO20
  10    CONTINUE
	I=NRAD(ISORT)+1
  20    NR=I-1
	DO 90 ISYM=1,NSYMOLD(IATOM)
	DO 30 I=0,NRADOLD(ISORT)
	ROTMPR(I)=DREAL(RO(I,ISYM,IATOM,ISPIN))
	ROTMPI(I)=DIMAG(RO(I,ISYM,IATOM,ISPIN))
  30    CONTINUE
	CALL SPLIN3(ROLD(0,ISORT),ROTMPR,DERIN,NRADOLD(ISORT)+1,
     &  NRADMAX+1,R(0,ISORT),WORK1(0,1),DEROUT,NR+1,NRADMAX+1,-1)
	CALL SPLIN3(ROLD(0,ISORT),ROTMPI,DERIN,NRADOLD(ISORT)+1,
     &  NRADMAX+1,R(0,ISORT),WORK1(0,2),DEROUT,NR+1,NRADMAX+1,-1)
	DO 40 I=0,NR
	RO(I,ISYM,IATOM,ISPIN)=DCMPLX(WORK1(I,1),WORK1(I,2))
  40    CONTINUE
	DO 50 I=NR+1,NRAD(ISORT)
	RO(I,ISYM,IATOM,ISPIN)=RO(NR,ISYM,IATOM,ISPIN)
  50    CONTINUE
  90    CONTINUE
 100    CONTINUE                                !!! over atoms
 110    CONTINUE                                !!! over spins
C  CORE DENSITY
	DO 270 ISPIN=1,NSPIN                     !!! over spins
	DO 260 ISORT=1,NSORT                     !!! over sort
	DO 210 I=0,NRAD(ISORT)
	IF(R(I,ISORT)-ROLD(NRADOLD(ISORT),ISORT).GT.1.D-09)GOTO220
 210    CONTINUE
	I=NRAD(ISORT)+1
 220    NR=I-1
	DO 230 I=0,NRADOLD(ISORT)
	ROTMPR(I)=ROCOR(I,ISORT,ISPIN)
 230    CONTINUE
	CALL SPLIN3(ROLD(0,ISORT),ROTMPR,DERIN,NRADOLD(ISORT)+1,
     &  NRADMAX+1,R(0,ISORT),WORK1(0,1),DEROUT,NR+1,NRADMAX+1,-1)
	DO 240 I=0,NR
	ROCOR(I,ISORT,ISPIN)=WORK1(I,1)
 240    CONTINUE
	DO 250 I=NR+1,NRAD(ISORT)
	ROCOR(I,ISORT,ISPIN)=ROCOR(NR,ISORT,ISPIN)
 250    CONTINUE
 260    CONTINUE                                !!! over sorts
 270    CONTINUE                                !!! over spins
C  CHECK WHETHER SCFFILE IS OLD
	CHK=0.D0
	DO 510 IVEC=1,3
	DO 510 I=1,3
	CHK=CHK+GBASOLD(I,IVEC)
	CHK=CHK+RBASOLD(I,IVEC)
 510    CONTINUE
	IF(ABS(CHK).LE.1.D-10)THEN 
	DO 520 IVEC=1,3
	GBASOLD(1,IVEC)=GBAS(1,IVEC)
	RBASOLD(1,IVEC)=RBAS(1,IVEC)
	DO 520 I=2,3
	GBASOLD(I,IVEC)=GBAS(I,IVEC)*ORTH(I)/ORTHOLD(I)
	RBASOLD(I,IVEC)=RBAS(I,IVEC)/ORTH(I)*ORTHOLD(I)
 520    CONTINUE
	ENDIF
C  PSEUDOCHARGE DENSITY FOURIER TRANSFORMED
	DO 650 ISPIN=1,NSPIN
	DO 610 IPLW=0,NPLWOLD
	OLDPS(IPLW)=RHOPS(IPLW,ISPIN)
 610    CONTINUE
	DO 620 IPLW=0,NPLW
	RHOPS(IPLW,ISPIN)=(0.D0,0.D0)
 620    CONTINUE
	NPLWI=-1
	DO 640 IPLW=0,NPLW
C  SET G IN UNITS OF GBAS
	X1=GPLW(1,IPLW)*RBAS(1,1)+GPLW(2,IPLW)*RBAS(2,1)+
     &  GPLW(3,IPLW)*RBAS(3,1)
	X2=GPLW(1,IPLW)*RBAS(1,2)+GPLW(2,IPLW)*RBAS(2,2)+
     &  GPLW(3,IPLW)*RBAS(3,2)
	X3=GPLW(1,IPLW)*RBAS(1,3)+GPLW(2,IPLW)*RBAS(2,3)+
     &  GPLW(3,IPLW)*RBAS(3,3)
	M1=ANINT(X1)
	M2=ANINT(X2)
	M3=ANINT(X3)
	IF(ABS(M1-X1).GE.1.D-05.OR.
     &  ABS(M2-X2).GE.1.D-05.OR.
     &  ABS(M3-X3).GE.1.D-05)STOP'<SPLRHO>:
     &  NEW RECIPROCAL VECTOR COORDINATES ARE NOT INTEGER'
	DO 630 JPLW=0,NPLWOLD
	X1OLD=GPLWOLD(1,JPLW)*RBASOLD(1,1)+
     &        GPLWOLD(2,JPLW)*RBASOLD(2,1)+
     &        GPLWOLD(3,JPLW)*RBASOLD(3,1)
	X2OLD=GPLWOLD(1,JPLW)*RBASOLD(1,2)+
     &        GPLWOLD(2,JPLW)*RBASOLD(2,2)+
     &        GPLWOLD(3,JPLW)*RBASOLD(3,2)
	X3OLD=GPLWOLD(1,JPLW)*RBASOLD(1,3)+
     &        GPLWOLD(2,JPLW)*RBASOLD(2,3)+
     &        GPLWOLD(3,JPLW)*RBASOLD(3,3)
	M1OLD=ANINT(X1OLD)
	M2OLD=ANINT(X2OLD)
	M3OLD=ANINT(X3OLD)
	IF(M1.EQ.M1OLD.AND.M2.EQ.M2OLD.AND.M3.EQ.M3OLD)THEN
	RHOPS(IPLW,ISPIN)=OLDPS(JPLW)
	NPLWI=NPLWI+1
	ENDIF
 630    CONTINUE
 640    CONTINUE
 650    CONTINUE
	WRITE(IUN,1010)NPLWOLD,NPLW,NPLWI
1010    FORMAT(1X,'Plane waves: old=',I7,'; new=',I7,'; coinsiding ',I7)  
	END
