	SUBROUTINE TOSEND(IPAN)
***********************************************************
*  Makes final form for the pseudodensity.                *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NKAP(NPANMAX),NPNT(NPANMAX),NDIV(3),NDIC(3)
	COMPLEX*16 YLM(LIMLMB,0:NBASMAX)
     &    ,EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX)
     &    ,CFTR(0:LMAXB,NSORTMAX,NKAPMAX,0:NBASMAX)
     &    ,EXPS(0:NPLWMAX),CHIS(0:NBASMAX),CONT(0:NBASMAX)
     &    ,EXPK(0:NPLWMAX),CHIK(0:NBASMAX),CHIL(0:NBASMAX)
     &    ,RFUN(NDIMMAX,0:MBASMAX),RINT0(NDIMMAX,NDIMMAX)
     &    ,RHOPS(0:NPLWMAX,NSPINMAX),CHIR(0:NBASMAX)
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &    ,PNTR(3),PNTK(3),PNT(3,KMAX,NPANMAX),WGT(KMAX,NPANMAX)
     &    ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),SH(3,NPANMAX)
     &    ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR,NPF                !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /BASIS/  TAU                                  !!! from init
	COMMON /POTCOM/ SWZ,SMT                              !!! from init
	COMMON /DENS/   PNTR,CFTR,YLM                        !!! from strgnt
	COMMON /PSRHO/  RHOPS                                !!! from tosint
        COMMON /STORE1/ RFUN,RINT0                           !!! from nultos
        COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from plwmsh
	COMMON /MESH/   NPNT,PNT,WGT                         !!! from ttrmsh
	COMMON /SPIN/   NSPIN                                !!! from init
        COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
        COMMON /INTTR/  NDIV,NDIC,SH                         !!! from init
	COMMON /INDX/   IND                                  !!! from lmtpar
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
        IF(KEYT.EQ.0)RETURN
        PNTK(1)=0.D0
        PNTK(2)=0.D0
        PNTK(3)=0.D0
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
        CALL FTRMAT(PNTK,1,IPAN)
C  DO OVER SPINS
	DO 1000 ISPIN=1,NSPIN                       !!! over spins
C  READ DENSITY PARAMETERS
        IREC=ISPIN
        READ(19,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  DO OVER LEFT INDEX
        DO 340 IATOM1=1,NATOM                       !!! over iatom1
        ISORT1=IS(IATOM1)
C  CALCULATE EXPONENTIAL FACTOR
        DO 10 IBAS=0,NBAS
        SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
        EXPS(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
  10    CONTINUE
        DO 330 IKAP1=1,NKAP(IPAN)                   !!! over energy
        DO 320 L1=0,ILSB(ISORT1)                    !!! over l1
        IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))GOTO320
        DO 310 M1=-L1,L1                            !!! over m1
        L1M1=L1*(L1+1)+M1+1
        IPAR1=IND(L1M1,IATOM1,IKAP1,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
        DO 20 IBAS=MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN) !! NG_1{large}
        CHIS(IBAS)=DCONJG(CFTR(L1,ISORT1,IKAP1,IBAS)*
     &  YLM(L1M1,IBAS)*EXPS(IBAS))
  20    CONTINUE
C  SET CONVOLUTION OF PSEUDOORBITAL WITH TOS-MATRIX
	DO 100 IBAS=0,NBAS
	CONT(IBAS)=(0.D0,0.D0)
 100	CONTINUE
        DO 240 IATOM=1,NATOM                        !!! over iatom
        ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
        DO 110 IBAS=0,NBAS                          !!! NGMAX{large}
        SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
        EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
 110    CONTINUE
        DO 230 IKAP=1,NKAP(IPAN)                    !!! over energy
        DO 220 L=0,ILSB(ISORT)                      !!! over l
        IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))GOTO220
        DO 210 M=-L,L                               !!! over m
        LM=L*(L+1)+M+1
        IPAR=IND(LM,IATOM,IKAP,1,IPAN)
C  SET LOWER PART OF THE MATRIX
        IF(IPAR1.LT.IPAR)RINT0(IPAR1,IPAR)=
     &  DCONJG(RINT0(IPAR,IPAR1))
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
        DO 120 IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
        CHIK(IBAS)=CFTR(L,ISORT,IKAP,IBAS)*YLM(LM,IBAS)*EXPK(IBAS)
 120    CONTINUE
C  CONVOLUTION
	DO 130 IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
	CONT(IBAS)=CONT(IBAS)+RINT0(IPAR1,IPAR)*CHIK(IBAS)
 130	CONTINUE 
 210    CONTINUE                                   !!! over m
 220    CONTINUE                                   !!! over l
 230    CONTINUE                                   !!! over energy
 240    CONTINUE                                   !!! over iatom
C  FOURIER TRANSFORM OF THE PSEUDOCHARGE DENSITY
C  1) SMALL-SMALL G CONTRIBUTION : HAS BEEN DONE BEFORE
C  2) SMALL-LARGE G CONTRIBUTION
	DO JBAS=0,MIN(NBAS,MBAS)
	CHIL(JBAS)=DCONJG(RFUN(IPAR1,JBAS))
	ENDDO
	DO IBAS=MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN)
	CHIR(IBAS)=DCONJG(CHIS(IBAS))
	ENDDO
        CALL CONVOL2(RHOPS(0,ISPIN),CHIL(0),CHIR(0),'P',
     &  0,MIN(NBAS,MBAS),MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
C  3) LARGE-SMALL G CONTRIBUTION
	DO IBAS=0,MIN(NBAS,MBAS)
	CHIR(IBAS)=RFUN(IPAR1,IBAS)
	ENDDO
        CALL CONVOL2(RHOPS(0,ISPIN),CHIS(0),CHIR(0),'P',
     &  MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN),0,MIN(NBAS,MBAS))
C  4) LARGE-LARGE G CONTRIBUTION
        CALL CONVOL2(RHOPS(0,ISPIN),CHIS(0),CONT(0),'P',
     &  MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN),MBAS+1,NBAS)
 310    CONTINUE                                !!! over m1
 320    CONTINUE                                !!! over l1
 330    CONTINUE                                !!! over energy
 340    CONTINUE                                !!! over iatom1
1000	CONTINUE                                !!! over spins
	END
