	SUBROUTINE TTRINT4(EF0,TOS,DOS,KEY)
***********************************************************
*      Calculate partial densities of states.             *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER   ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),IS(NPAT),IP(NPAT,NOPRMAX)
     &   ,NKAP(NPANMAX),NBNDF(NPANMAX),NBNDT(NPANMAX)
     &   ,NBNDE(NPANMAX),NPNT(NPANMAX)
	DIMENSION EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &   ,WEIGH(NDIMMAX*NSPINMAX,KMAX),WEIGD(NDIMMAX*NSPINMAX,KMAX)
	COMPLEX*16 ASUM(0:LMAXT,NSORTMAX,NKAPMAX,NKAPMAX)
     &   ,ATOS(0:LMAXT,NSORTMAX,NKAPMAX,NKAPMAX,NPANMAX,NSPINMAX,0:5)
     &   ,ADOS(0:LMAXT,NSORTMAX,NKAPMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,PNT(3,KMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT
	COMMON /MESH/   NPNT,PNT                !!! from ttrmsh
	COMMON /ENERGY/ EARR,WEIGH,WEIGD        !!! from lmtbnd
	COMMON /KAPPAR/ NPAN,NKAP               !!! from init
	COMMON /TOSDOS/ ATOS,ADOS               !!! from ttrint4
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT       !!! from init
	COMMON /OUT1/   ICON,IFTR,IKOV,IWF,ITMP,IBAN,IPOT
     &                 ,IPTN,IDOS,ISCF,IOUT
	COMMON /ORBS/   NORBS                   !!! from init
	COMMON /SPIN/   NSPIN                   !!! from init
	COMMON /UNIT/   IUN                     !!! from init
	DATA PI/3.141592653589793D0/
C  SET ZEROES
	TOS=0.D0
	DOS=0.D0
	DO ISPIN=1,NSPIN
	DO IKAP1=1,NKAP(1)
	DO IKAP=1,NKAP(1)
	DO ISORT=1,NSORT
	DO L=0,ILST(ISORT)
	ADOS(L,ISORT,IKAP1,IKAP,1,ISPIN)=0.D0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C *********** TETRAHEDRON METHOD FOR MAIN PANEL ***********
        DO IORBS=1,NORBS                         !!! over spinor components
        DO IBNDS=1,NSPIN                         !!! over spin subbands
        IF(NORBS.EQ.1)ISPIN=IBNDS
        IF(NORBS.EQ.2)ISPIN=IORBS
	DO IBNDT=1,NBNDT(1)                      !!! over bands 
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IPNT=1,NPNT(1)                        !!! over k-points
	IF(IDOS.NE.0.AND.IBNDT.LE.NBNDF(1).AND.
     &  ABS(WEIGD(IBAND,IPNT)).GT.1.D-10)THEN
C  READ TL-CHARACTERS
        IREC=IBNDT+NBNDF(1)*(IBNDS-1)+NBNDF(1)*NSPIN*(IORBS-1)+
     &  NBNDF(1)*NSPIN*NORBS*(IPNT-1)
	READ(17,REC=IREC)((((ASUM(L,ISORT,IKAP1,IKAP),L=0,ILST(ISORT)),
     &  ISORT=1,NSORT),IKAP=1,NKAP(1)),IKAP1=1,NKAP(1))
	DO IKAP1=1,NKAP(1)                       !!! over energies
	DO IKAP=1,NKAP(1)                        !!! over energies
	DO ISORT=1,NSORT                         !!! over isort
	DO L=0,ILST(ISORT)                       !!! over l
	ADOS(L,ISORT,IKAP1,IKAP,1,ISPIN)=
     &  ADOS(L,ISORT,IKAP1,IKAP,1,ISPIN)+
     &  ASUM(L,ISORT,IKAP1,IKAP)*WEIGD(IBAND,IPNT)
        ENDDO                                     !!! over l
        ENDDO                                     !!! over isort
        ENDDO                                     !!! over energies
        ENDDO                                     !!! over energies
	ENDIF
        TOS=TOS+WEIGH(IBAND,IPNT)
	DOS=DOS+WEIGD(IBAND,IPNT)
        ENDDO                                     !!! over k-points
        ENDDO                                     !!! over valence bands
        ENDDO                                     !!! over spin subbands
        ENDDO                                     !!! over spinor components
	END
