	SUBROUTINE SCF1
************************************************************
*   The calculation of the energy band structure in terms  *
*   of LMTO method (O.K.Andersen,Phys.Rev.B12,3060(1975))  *
*   Written by S.Yu.Savrasov (P.N.Lebedev Physical Instit.)*
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER*8 ST,FN
	COMMON /CONTROL/MANAGE                 !!! from init
	COMMON /SCF1COM/NITER1                 !!! from init
	COMMON /SPIN/   NSPIN                  !!! from init
	COMMON /UNIT/   IUN                    !!! from init
	LOGICAL EXIT
	DATA ST/'started'/,FN/'finished'/
C  CALCULATE STRUCTURE CONSTANTS
	call timel(times)
	write(iun,1001)st,times
	CALL STRMSH         !!!
	call timel(timef)
	write(iun,1001)fn,timef
C  CALCULATE ATOMIC CELL ENVELOPES
	call timel(times)
	write(iun,1002)st,times
	CALL SCELLS         !!!
	call timel(timef)
	write(iun,1002)fn,timef
1001  FORMAT('******* STRMSH ',A8,' ; CPU time: ',G14.7,' ************')
1002  FORMAT('******* SCELLS ',A8,' ; CPU time: ',G14.7,' ************')
	END
