	SUBROUTINE FATBND(IPNT,IPAN)
**********************************************************
* Program calculates tlm-characters of wave functions    *
* to plot fat bands.                                     *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NBNDF(NPANMAX),NPNT(NPANMAX)
     &   ,NBNDE(NPANMAX),NBNDT(NPANMAX),NKAP(NPANMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,OHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,OJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NPANMAX,NSPINMAX)
     &   ,APH(LIMLMB, NPAT,NKAPMAX,NSPINMAX),TC(-3:3,7,0:3)
     &   ,APJ(LIMLMT1,NPAT,NKAPMAX,NSPINMAX),TS(7,-3:3,0:3)
     &   ,ACH(LIMLMB,NKAPMAX),ACJ(LIMLMB,NKAPMAX)
	DIMENSION TLMC(LIMLMB,NPAT,NSPINMAX)
     &   ,PNT(3,KMAX,NPANMAX),GAM(0:LMAXT,NSORTMAX),SMT(NSORTMAX)
     &   ,EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
	LOGICAL LOG,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT  !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                 !!! from init
	COMMON /POTCOM/ SWZ,SMT                               !!! from init
        COMMON /ENERGY/ EARR                                  !!! from lmtbnd
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                     !!! from init
	COMMON /SUMPAR/ OHH,OJH,OHJ,OJJ                       !!! from ovrpar
	COMMON /LATPAR/ PAR                                   !!! from init
	COMMON /LMTPAR/ GAM                                   !!! from potpar
	COMMON /OUT1/   ICON,IFTR,IKOV,IPSI,ITMP,IBAN,IPOT    !!! from init 
     &                 ,IFAT,IDOS,ISCF,IOUT
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                     !!! from init
	COMMON /MESH/   NPNT,PNT                              !!! from init
	COMMON /ORBS/   NORBS                                 !!! from init
	COMMON /SPIN/   NSPIN                                 !!! from init
	IF(IFAT.EQ.0)RETURN
	IF(IPAN.GT.1)RETURN
	CALL TRANSS(TS)                  !!! built transformation matrices
	CALL TRANSC(TC)                  !!! built transformation matrices
	WRITE(22)(PNT(IXYZ,IPNT,IPAN),IXYZ=1,3),
     &  (EARR(IBAND,IPNT,IPAN),IBAND=1,NBNDT(IPAN)*NSPIN)
        DO 2000 IBNDS=1,NSPIN            !!! over spin subbands
        DO 1000 IBNDT=1,NBNDF(IPAN)      !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
C READ WAVE FUNCTIONS
	DO IORBS=1,NORBS
        IF(NORBS.EQ.1)ISPIN=IBNDS
        IF(NORBS.EQ.2)ISPIN=IORBS
	DO IKAP=1,NKAP(IPAN)
        IREC=IKAP+NKAP(IPAN)*(IBNDT-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(IORBS-1)
        READ(14,REC=IREC)
     &  ((APH(LM,IATOM,IKAP,IORBS),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM),
     &  ((APJ(LM,IATOM,IKAP,IORBS),LM=1,(ILST(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM)
	ENDDO
	ENDDO
C SET NORMALIZATION
	ANORM=0.D0
	DO IORBS=1,NORBS                 !!! over spinors   
        IF(NORBS.EQ.1)ISPIN=IBNDS
        IF(NORBS.EQ.2)ISPIN=IORBS
	DO IKAP1=1,NKAP(IPAN)            !!! over energies
	DO IKAP=1,NKAP(IPAN)             !!! over energies
	DO IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)               !!! over l
	DO M=-L,L                        !!! over m
	LM=L*(L+1)+M+1
	IF(LTPAN(L,IATOM,IKAP1,IPAN).AND.LTPAN(L,IATOM,IKAP,IPAN))
     &	ANORM=ANORM+CONJG(APH(LM,IATOM,IKAP1,IORBS))*
     &  OHH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)*
     &  APH(LM,IATOM,IKAP,IORBS)
	IF(LTPAN(L,IATOM,IKAP,IPAN))
     &	ANORM=ANORM-CONJG(APJ(LM,IATOM,IKAP1,IORBS))*
     &  OJH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)*
     &  APH(LM,IATOM,IKAP,IORBS)
	IF(LTPAN(L,IATOM,IKAP1,IPAN))
     &	ANORM=ANORM-CONJG(APH(LM,IATOM,IKAP1,IORBS))*
     &  OHJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)*
     &  APJ(LM,IATOM,IKAP,IORBS)
	ANORM=ANORM+CONJG(APJ(LM,IATOM,IKAP1,IORBS))*
     &  OJJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)*
     &  APJ(LM,IATOM,IKAP,IORBS)
        ENDDO                            !!! over m
        ENDDO                            !!! over l
        ENDDO                            !!! over atoms
        ENDDO                            !!! over energies
        ENDDO                            !!! over energies
        ENDDO                            !!! over spinors
	IF(ABS(ANORM).LE.1.D-10)ANORM=1.D0
C SET TLM-CHARACTER IN CUBIC HARMONIC REPRESENTATION
	DO IORBS=1,NORBS                 !!! over spinors   
        IF(NORBS.EQ.1)ISPIN=IBNDS
        IF(NORBS.EQ.2)ISPIN=IORBS
	DO IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,MIN(ILSB(ISORT),3)        !!! over l
C TRANSFERE TO CUBIC HARMONICS
	DO IKAP=1,NKAP(IPAN)
	DO IXYZ=1,2*L+1
	LC=IXYZ+L*L
	ACH(LC,IKAP)=(0.D0,0.D0)
	ACJ(LC,IKAP)=(0.D0,0.D0)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(LTPAN(L,IATOM,IKAP,IPAN))
     &	ACH(LC,IKAP)=ACH(LC,IKAP)+APH(LM,IATOM,IKAP,IORBS)*TC(M,IXYZ,L)
	ACJ(LC,IKAP)=ACJ(LC,IKAP)+APJ(LM,IATOM,IKAP,IORBS)*TC(M,IXYZ,L)
	ENDDO
	ENDDO
	ENDDO
C SET TLM-CHARACTERS
	DO M=-L,L                        !!! over m
	LM=L*(L+1)+M+1
	TLMC(LM,IATOM,IORBS)=0.D0
	DO IKAP1=1,NKAP(IPAN)
	DO IKAP =1,NKAP(IPAN)
	IF(LTPAN(L,IATOM,IKAP1,IPAN).AND.LTPAN(L,IATOM,IKAP,IPAN))
     &	TLMC(LM,IATOM,IORBS)=TLMC(LM,IATOM,IORBS)+
     &	CONJG(ACH(LM,IKAP1))*OHH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)*
     &  ACH(LM,IKAP)
	IF(LTPAN(L,IATOM,IKAP,IPAN))
     &	TLMC(LM,IATOM,IORBS)=TLMC(LM,IATOM,IORBS)-
     &  CONJG(ACJ(LM,IKAP1))*OJH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)*
     &  ACH(LM,IKAP)
	IF(LTPAN(L,IATOM,IKAP1,IPAN))
     &	TLMC(LM,IATOM,IORBS)=TLMC(LM,IATOM,IORBS)-
     &  CONJG(ACH(LM,IKAP1))*OHJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)*
     &  ACJ(LM,IKAP)
	TLMC(LM,IATOM,IORBS)=TLMC(LM,IATOM,IORBS)+
     &	CONJG(ACJ(LM,IKAP1))*OJJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN)*
     &  ACJ(LM,IKAP)
C	TLMC(LM,IATOM,IORBS)=TLMC(LM,IATOM,IORBS)/ANORM
	ENDDO
	ENDDO
	ENDDO                            !!! over m
        ENDDO                            !!! over l
        ENDDO                            !!! over atoms
        ENDDO                            !!! over spinors
C  SAVE TLM-CHARACTERS IN FILE
	WRITE(22)(((TLMC(LM,IATOM,IORBS),LM=1,
     &  (ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IORBS=1,NORBS)
1000	CONTINUE                         !!! over bands
2000	CONTINUE                         !!! over spin subbands
	IF(IPAN.EQ.1.AND.IPNT.EQ.NPNT(1))CLOSE(22)
	END
