	SUBROUTINE FTRMAT(PNTK,ID,IPAN)
***********************************************************
*  Calculates fourier transform for the pseudoorbitals.   *
*  S.Savrasov, Last revison 21.06.94.                     *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,NDIV(3),NDIC(3),LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,ILSV(NSORTMAX),NKAP(NPANMAX),NPNT(NPANMAX)
	COMPLEX*16 YLM(LIMLMB,0:NBASMAX),CCOF(0:LMAXB,NKAPMAX,NSORTMAX)
     &    ,EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX),DELE,EXPGK
     &    ,CFTR(0:LMAXB,NSORTMAX,NKAPMAX,0:NBASMAX)
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &    ,PNT(3,KMAX,NPANMAX),PNTR(3),PNTK(3),ORTH(2:3)
     &    ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &    ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &    ,C(0:LMAXV+1,LMMAXV1,LMMAXV1)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR                    !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /BASIS/  TAU                                  !!! from init
	COMMON /MESH/   NPNT,PNT                             !!! from init
	COMMON /INTTR/  NDIV,NDIC,SH                         !!! from init
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from init
        COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
	COMMON /POTCOM/ SWZ,SMT                              !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
	COMMON /DENS/   PNTR,CFTR,YLM                        !!! from ftrmat
	COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
	COMMON /PANPAR/ LTPAN,LSPAN                          !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
        COMMON /GAUNT/  C                                    !!! from gdata
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
        PNTR(1)=PNTK(1)*2.D0*PI/PAR
        PNTR(2)=PNTK(2)*2.D0*PI/PAR
        PNTR(3)=PNTK(3)*2.D0*PI/PAR
C  CALCULATE SPHERICAL HARMONICS
	LMB=0
	DO 20 ISORT=1,NSORT
	DO 20 IKAP=1,NKAP(IPAN)
	DO 10 L=0,ILSB(ISORT)
	IF(.NOT.LSPAN(L,ISORT,IKAP,IPAN))GOTO10
	LMB=MAX(L,LMB)
 10     CONTINUE
 20     CONTINUE
	IF(ID.EQ.0)NDOT=MIN(NBAS,MBAS)
	IF(ID.EQ.1)NDOT=NBAS
	DO 60 IBAS=0,NDOT
	GKX=(GPLW(1,IBAS)+PNTK(1))*2.D0*PI/PAR
	GKY=(GPLW(2,IBAS)+PNTK(2))*2.D0*PI/PAR
	GKZ=(GPLW(3,IBAS)+PNTK(3))*2.D0*PI/PAR
	ABSG=SQRT(GKX**2+GKY**2+GKZ**2)
C  CHECK WHETHER K+G=0
	IF(ABSG.GE.1.D-10)THEN
	CALL SPHHARM(GKX/ABSG,GKY/ABSG,GKZ/ABSG,LMB,YLM(1,IBAS))
	DO 40 L=0,LMB
	IF(L.EQ.0)GKL=1.D0
	IF(L.NE.0)GKL=ABSG**L
	DO 30 M=-L,L
	LM=L*(L+1)+M+1
	YLM(LM,IBAS)=YLM(LM,IBAS)*GKL
 30	CONTINUE
 40 	CONTINUE
	ELSE
	YLM(1,IBAS)=1.D0/SQRT(4.D0*PI)
	DO 50 LM=2,(LMB+1)**2
	YLM(LM,IBAS)=(0.D0,0.D0)
 50     CONTINUE
	ENDIF
 60     CONTINUE
C  *** CALCULATE FOURIER COEFFICIENTS ***
	DO 90 ISORT=1,NSORT                           !!! over isort
	DO 80 IKAP=1,NKAP(IPAN)                       !!! over ikap
	DO 70 L=0,ILSB(ISORT)                         !!! over l
	CCOF(L,IKAP,ISORT)=4.D0*PI/OMEGAC*SMT(ISORT)**(L+1)/
     &  DFACT(2*L-1)*EXP(EKAP(IKAP,IPAN)*0.25D0/
     &  ETA(L,ISORT,IKAP,IPAN)**2)
 70     CONTINUE
 80     CONTINUE
 90     CONTINUE
C  GET FOURIER TRANSFORM FOR THE PSEUDOORBITALS
	DO 140 ISORT=1,NSORT                          !!! over isort
	DO 130 IKAP=1,NKAP(IPAN)                      !!! over ikap
	DO 120 L=0,ILSB(ISORT)                        !!! over l
	IF(ID.EQ.0)NDOL=MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
	IF(ID.EQ.1)NDOL=LBAS(L,ISORT,IKAP,IPAN)
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	DO 100 IBAS=0,NDOL                            !!! over ibas
	GKX=(GPLW(1,IBAS)+PNTK(1))*2.D0*PI/PAR
	GKY=(GPLW(2,IBAS)+PNTK(2))*2.D0*PI/PAR
	GKZ=(GPLW(3,IBAS)+PNTK(3))*2.D0*PI/PAR
	GD2=GKX**2+GKY**2+GKZ**2
	ABSG=SQRT(GD2)
	DELE=1.D0/(GD2-EKAP(IKAP,IPAN))                     
	EXPGK=EXP(-GD2*0.25D0/ETA(L,ISORT,IKAP,IPAN)**2)
	CFTR(L,ISORT,IKAP,IBAS)=CCOF(L,IKAP,ISORT)*DELE*EXPGK
100     CONTINUE                                     !!! over ibas
	ELSE
	DO 110 IBAS=0,NDOL                           !!! over ibas
	CFTR(L,ISORT,IKAP,IBAS)=(0.D0,0.D0)
110     CONTINUE                                     !!! over ibas
	ENDIF
120     CONTINUE                                     !!! over l
130     CONTINUE                                     !!! over ikap
140     CONTINUE                                     !!! over isort
	END
