	SUBROUTINE INTVAR(IPNT,IPAN)
***********************************************************
*  Calculates pseudopotential contribution to the         *
*  Pulay force.                                           *
*  S.Savrasov, Last revison 19.03.95.                     *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,NKAP(NPANMAX),LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),ILSV(NSORTMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NPNT(NPANMAX),NDIV(3),NDIC(3)
        INTEGER INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3)
	COMPLEX*16 VPS(0:NPLWMAX,NSPINMAX),YLM(LIMLMB,0:NBASMAX)
     &    ,PILF(-1:1,NPAT,NSPINMAX,NDIMMAX*NSPINMAX,2)
     &    ,APH(LIMLMB,NPAT,NKAPMAX),PFI(3,NPAT),PFM(-1:1,NPAT)
     &    ,EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX)
     &    ,CFTR(0:LMAXB,NSORTMAX,NKAPMAX,0:NBASMAX)
     &    ,PFVAL(-1:1,NPAT,NPANMAX,NSPINMAX,2),EXPS(0:NBASMAX)
     &    ,CONVT(0:NBASMAX),PSIK(0:NBASMAX),PSIX(0:NBASMAX)
     &    ,DCONV(0:NBASMAX),DPSI(0:NBASMAX),EXPK(0:NBASMAX)
     &    ,XFUN(NDIMMAX,0:MBASMAX),VINT0(NDIMMAX,NDIMMAX)
     &    ,VPSINT(0:NPLWMAX,NSPINMAX)
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &    ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),PNTR(3),PNTK(3)
     &    ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),ORTH(2:3)
     &    ,PNT(3,KMAX,NPANMAX),SH(3,NPANMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR,NPF                !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /BASIS/  TAU                                  !!! from init
	COMMON /POTCOM/ SWZ,SMT                              !!! from init
	COMMON /DENS/   PNTR,CFTR,YLM                        !!! from strgnt
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from plwmsh
	COMMON /PSVCOM/ VPS,VPSINT                           !!! from vpseudo
        COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
        COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG      !!! from plwmsh
        COMMON /PILAUF/ PFVAL,PILF                           !!! from intvar
        COMMON /STORE1/ XFUN,VINT0                           !!! from intpar
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
        COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
        COMMON /MESH/   NPNT,PNT                             !!! from init
        COMMON /INTTR/  NDIV,NDIC,SH                         !!! from init
	COMMON /INDX/   IND                                  !!! from lmtpar
	COMMON /ORBS/   NORBS                                !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
	IF(NPF.EQ.0)RETURN
C  FIND K-POINT PNTK=K+G WHICH HAS A MINIMAL LENGTH
        XK=PNT(1,IPNT,IPAN)+SH(1,IPAN)
        YK=PNT(2,IPNT,IPAN)+SH(2,IPAN)
        ZK=PNT(3,IPNT,IPAN)+SH(3,IPAN)
        CALL REDUC2(XK,YK,ZK,NBAS,GPLW(1,0),PNTK(1),PNTK(2),PNTK(3),
     &  GRX,GRY,GRZ)
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
        CALL FTRMAT(PNTK,0,IPAN)
C  DO GLOBALLY OVER BANDS, SPINS
        DO 3000 IORBS=1,NORBS                          !!! over spinor components
        DO 2000 IBNDS=1,NSPIN                          !!! over spin subbands
        IF(NORBS.EQ.1)ISPIN=IBNDS
        IF(NORBS.EQ.2)ISPIN=IORBS
C  READ POTENTIAL PARAMETERS
        IREC=ISPIN
        IF(KEYT.GT.0)
     &  READ(18,REC=ISPIN)((VINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((XFUN(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
        DO 1000 IBNDT=1,NBNDF(IPAN)                    !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
C  READ EXPANSION COEFFICIENTS FOR OCCUPIED BANDS
        DO IKAP=1,NKAP(IPAN)                           !!! over energies
        IREC=IKAP+NKAP(IPAN)*(IBNDT-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*(IBNDS-1)+
     &  NKAP(IPAN)*NBNDF(IPAN)*NSPIN*(IORBS-1)
        READ(14,REC=IREC)
     &  ((APH(LM,IATOM,IKAP),LM=1,(ILSB(IS(IATOM))+1)**2),
     &  IATOM=1,NATOM)
        ENDDO                                          !!! over energies
C  SET |PSI(k+G)> 
        DO IBAS=0,MIN(NBAS,MBAS)
        PSIK(IBAS)=(0.D0,0.D0)
        PSIX(IBAS)=(0.D0,0.D0)
	ENDDO
        DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
        DO IBAS=0,MIN(NBAS,MBAS)
        SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
        EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
        ENDDO      
C  PSEUDOWAVEFUNCTION:
        DO IKAP=1,NKAP(IPAN)                           !!! over energies
        DO L=0,ILSB(ISORT)                             !!! over l
        IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
        DO M=-L,L                                      !!! over m
        LM=L*(L+1)+M+1
	IPAR=IND(LM,IATOM,IKAP,1,IPAN)
        MINB=MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
        DO IBAS=0,MINB
        PSIK(IBAS)=PSIK(IBAS)+APH(LM,IATOM,IKAP)*
     &  CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
        ENDDO      
	IF(KEYT.NE.0)THEN
        DO IBAS=0,MIN(NBAS,MBAS) 
        PSIX(IBAS)=PSIX(IBAS)+DCONJG(APH(LM,IATOM,IKAP)*
     &  EXPK(0))*XFUN(IPAR,IBAS)
        ENDDO      
	ENDIF
        ENDDO                                          !!! over m
	ENDIF
        ENDDO                                          !!! over l
        ENDDO                                          !!! over ikap
        ENDDO                                          !!! over iatom
C  SET CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
        M1D=KGMAX(1)-KGMIN(1)+1
        M2D=KGMAX(2)-KGMIN(2)+1
        M3D=KGMAX(3)-KGMIN(3)+1
        M12D=M1D*M2D
        M123D=M1D*M2D*M3D
	DO IBAS=0,MIN(NBAS,MBAS)
	CONVT(IBAS)=PSIX(IBAS)
        M1I=KVEC(1,IBAS)+KGMIN(1)
        M2I=KVEC(2,IBAS)+KGMIN(2)
        M3I=KVEC(3,IBAS)+KGMIN(3)
	DO JBAS=0,MIN(NBAS,MBAS)
        M1K=KVEC(1,JBAS)-M1I
        M2K=KVEC(2,JBAS)-M2I
        M3K=KVEC(3,JBAS)-M3I
        IFTR=1+M1K+M1D*M2K+M12D*M3K
        KPLW=-1
        IF(IFTR.GT.0.AND.IFTR.LE.M123D)KPLW=INDG(IFTR)
        IF(KPLW.GE.0)
     &	CONVT(IBAS)=CONVT(IBAS)+DCONJG(PSIK(JBAS))*VPSINT(KPLW,ISPIN)
        ENDDO      
        ENDDO      
C  *** DO GLOBALLY OVER DISPLACEMENTS AND POLARIZATIONS ***
	DO INUC=1,NATOM                                !!! over displacements
	DO IXYZ=1,3                                    !!! over polarizations
C  SET Delta|PSI(k+G)>
        DO IBAS=0,MIN(NBAS,MBAS)
        DPSI(IBAS)=(0.D0,0.D0)
        ENDDO      
        DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
	IF(IATOM.EQ.INUC)THEN
C  CALCULATE EXPONENTIAL FACTOR
        DO IBAS=0,MIN(NBAS,MBAS)
        SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
        EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
        ENDDO      
C  PSEUDOWAVEFUNCTION CHANGE IN FIRST ORDER
        DO IKAP=1,NKAP(IPAN)                           !!! over energies
        DO L=0,ILSB(ISORT)                             !!! over l
        IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
        DO M=-L,L                                      !!! over m
        LM=L*(L+1)+M+1
        MINB=MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
        DO IBAS=0,MINB
        DPSI(IBAS)=DPSI(IBAS)+APH(LM,IATOM,IKAP)*
     &  CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)*
     &  (0.D0,-1.D0)*(GPLW(IXYZ,IBAS)+PNTK(IXYZ))*2.D0*PI/PAR
        ENDDO      
        ENDDO                                          !!! over m
	ENDIF
        ENDDO                                          !!! over l
        ENDDO                                          !!! over ikap
	ENDIF
        ENDDO                                          !!! over iatom
C  SET INTERSTITIAL CONTRIBUTION TO THE PULAY FORCE
	PFI(IXYZ,INUC)=(0.D0,0.D0)
	DO IBAS=0,MIN(NBAS,MBAS)
	PFI(IXYZ,INUC)=PFI(IXYZ,INUC)+CONVT(IBAS)*DPSI(IBAS)
        ENDDO      
	PFI(IXYZ,INUC)=PFI(IXYZ,INUC)+DCONJG(PFI(IXYZ,INUC))
        ENDDO                                          !!! over polarizations
        ENDDO                                          !!! over displacements
C  TRANSFERE TO CYCLIC COORDINATE SYSTEM
	DO INUC=1,NATOM
	PFM(-1,INUC)=+1.D0/SQRT(2.D0)*
     &                    (PFI(1,INUC)-(0.D0,1.D0)*PFI(2,INUC))
	PFM(+1,INUC)=-1.D0/SQRT(2.D0)*
     &                    (PFI(1,INUC)+(0.D0,1.D0)*PFI(2,INUC))
	PFM(0,INUC)=PFI(3,INUC)
	DO MY=-1,1
	PILF(MY,INUC,IORBS,IBAND,2)=PFM(MY,INUC)
        ENDDO      
        ENDDO      
C  STORE FOR BANDS CROSSING THE FERMI LEVEL
        IF(IBNDT.GE.NBNDE(IPAN))THEN !!! write for fermi states
        IF(IPAN.GT.1)STOP'<INTVAR> ERROR IN WRITE STATEMENT'
        IREC=IBNDT-NBNDE(1)+1+
     &  (NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &  (NBNDF(1)-NBNDE(1)+1)*NSPIN*(IORBS-1)+
     &  (NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
        WRITE(16,REC=IREC)(((PILF(MY,INUC,IORBS,IBAND,IMI),
     &  MY=-1,1),INUC=1,NATOM),IMI=1,2)
        ENDIF
1000    CONTINUE                                !!! over bands
2000    CONTINUE                                !!! over spin subbands
3000    CONTINUE                                !!! over spinor components
	END
