	SUBROUTINE MIXRO1(ITER,EXIT)
*****************************************
*   Admixture in the main SCF loop      *
*****************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &    ,NRAD(NSORTMAX),NTYPE(NSORTMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,RHOPS(0:NPLWMAX,NSPINMAX),RHOPSOLD(0:NPLWMAX,NSPINMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
     &    ,WORK1(0:NRADMAX),WORK2(0:NRADMAX)
     &    ,ROINP,ROOUT,RONEW,AMINP,AMOUT,AMNEW
     &    ,AMTOT(NSYMMAX,NPAT,NSPINMAX),DELRHO
     &    ,ROOLD(0:NRADMAX,NSPINMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),ORTH(2:3)
     &    ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &    ,ROCOR(0:NRADMAX,NSORTMAX,NSPINMAX),Z(NSORTMAX)
     &    ,ROCOLD(0:NRADMAX,NSPINMAX),ZCOR(NSORTMAX)
	CHARACTER*10 TXTEL(NSORTMAX)
	CHARACTER*60 INIFILE,CONFILE,SRFFILE,KOVFILE,PTNFILE,WFFILE
     &   ,TMPFILE,POTFILE,SCFFILE,OUTFILE,BNDFILE,DOSFILE
	LOGICAL SYM(LMMAXV,NPAT),EXIT
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from init
	COMMON /MIXRHO1/ADMIX1,ADMIN,ADMAX,KEY,ADMOPT        !!! from mixro1
	COMMON /MIXMAG1/ADMSPN,ASMIN,ASMAX,KSP,ADSPIN        !!! from mixro1
        COMMON /MIXBROY/LBROY,IBROY,ADMIXB,ADMIXH            !!! from mixrob
	COMMON /DENS/   RO,ROVALDS,ROCOR                     !!! from rofull
	COMMON /PSRHO/  RHOPS                                !!! from ttrint2
	COMMON /STORE1/ RHOPSOLD                             !!! tmp.storage
	COMMON /SYMMLM/ SYM,LMSYM                            !!! from symmlm
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT                   !!! from radmsh
	COMMON /MULTRO/ Z,ZCOR,AMTOT                         !!! from multro
	COMMON /OUT1/   ICON,ISRF,IKOV,IWF,ITMP,IBND,IPOT
     &                 ,IPTN,IDOS,ISCF,IOUT
	COMMON /OUT2/   CONFILE,SRFFILE,KOVFILE, WFFILE,TMPFILE,BNDFILE
     &                 ,POTFILE,PTNFILE,DOSFILE,SCFFILE,OUTFILE
	COMMON /PLWMESH/NPLW                                 !!! from plwmsh
	COMMON /ACCU/   EPSTOT,EPSRHO,EPSMAG                 !!! from nmtdat
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /TXTEL/  TXTEL                                !!! from init
	COMMON /UNIT/   IUN,IUT,IUR                          !!! from init
	DATA PI/3.141592653589793D0/
	IF(ITER.EQ.0)RETURN
C CALCULATE NEW ABSOLUTE CHARGE TRANFERE AND MAGNETISATION
	QTOT=0.D0
	ATOT=0.D0
	DO 10 IATOM=1,NATOM
	QTOT=QTOT+ABS(AMTOT(1,IATOM,1)+AMTOT(1,IATOM,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
	ATOT=ATOT+ABS(AMTOT(1,IATOM,1)-AMTOT(1,IATOM,NSPIN))
	NTYPE(IS(IATOM))=0
  10    CONTINUE
C FIND OPTIMAL ADMIXTURE
        IF(LBROY.LT.0)THEN
        CALL PRATTC(QTOT,ITER,KEY,ADMIX1,ADMIN,ADMAX,ADMOPT)
        CALL PRATTM(ATOT,ITER,KSP,ADMSPN,ASMIN,ASMAX,ADSPIN)
        ELSEIF(LBROY.GE.0)THEN
C SET INPUT ADMIXTURE IF BROYDEN IS ON.
        ADMOPT=ADMIXH
        ADSPIN=ADMIXH
        ENDIF
        IF(ITER.EQ.1)ADMCOR=1.D0
        IF(ITER.NE.1)ADMCOR=ADMOPT
	DZ=0.D0    ! charge difference in MTs
	DM=0.D0    ! magnetisation difference in MTs
	DI=0.D0    ! charge difference in cell
	DMI=0.D0   ! magnetisation difference in cell
C OPEN FILE WITH THE OLD CHARGE DENSITY
	OPEN(3,FILE=SCFFILE,STATUS='OLD',FORM='UNFORMATTED')
	READ(3)NATOM,NSORT  !!! hope they are right 
	READ(3)
	READ(3)((RHOPSOLD(IPLW,ISPIN),IPLW=0,NPLW),ISPIN=1,NSPIN)
	DI=DI+OMEGAC*ABS(RHOPS(0,1)+RHOPS(0,NSPIN)-RHOPSOLD(0,1)-
     &  RHOPSOLD(0,NSPIN))/2.D0*DBLE(NSPIN)
	DMI=DMI+OMEGAC*ABS(RHOPS(0,1)-RHOPS(0,NSPIN)-RHOPSOLD(0,1)+
     &  RHOPSOLD(0,NSPIN))
C  PSEUDOCHARGE FOURIER TRANSFORMED
	IF(LBROY.LT.0)THEN
	DO 20 IPLW=0,NPLW
	ROOUT=(RHOPS(IPLW,1)+RHOPS(IPLW,NSPIN))/2.D0*DBLE(NSPIN)
	ROINP=(RHOPSOLD(IPLW,1)+RHOPSOLD(IPLW,NSPIN))/2.D0*DBLE(NSPIN)
	RONEW=ADMOPT*ROOUT+(1.D0-ADMOPT)*ROINP
	AMOUT=(RHOPS(IPLW,1)-RHOPS(IPLW,NSPIN))
	AMINP=(RHOPSOLD(IPLW,1)-RHOPSOLD(IPLW,NSPIN))
	AMNEW=ADSPIN*AMOUT+(1.D0-ADSPIN)*AMINP
	RHOPS(IPLW,1)=(RONEW+AMNEW)/DBLE(NSPIN)
	RHOPS(IPLW,NSPIN)=(RONEW-AMNEW)/DBLE(NSPIN)
  20    CONTINUE
	ENDIF
C DO OVER ALL ATOMS IN CELL
	DO 110 IATOM=1,NATOM                      !!! over atoms in cell
	ISORT=IS(IATOM)
	DO 30 IREAD=1,2
  30    READ(3)               !!! skip two lines  !!!
        DO 70 L=0,ILSV(ISORT)                     !!! over l
        DO 70 M=-L,L                              !!! over m
        LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN                     !!! for non-zero components
	ISYM=LMSYM(LM,IATOM)
	READ(3) L0M0
	IF(L0M0.NE.LM)STOP'<MIXRO>: L0M0.NE.LM'
	READ(3)((ROOLD(I,ISPIN),I=0,NRAD(ISORT)),ISPIN=1,NSPIN)
C DEFINE CHARGE CONVERGENCY BETWEEN ITERATIONS
	DO 40 IRAD=0,NRAD(ISORT)
	DELRHO=(RO(IRAD,ISYM,IATOM,1)+RO(IRAD,ISYM,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)-(ROOLD(IRAD,1)+ROOLD(IRAD,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	WORK1(IRAD)=WEIGHT(IRAD,IS(IATOM))*DCONJG(DELRHO)*
     &  DELRHO/4.D0/PI
  40    CONTINUE
	CALL CQD(H(IS(IATOM)),WORK1,WORK2,NRAD(ISORT)+1)
	DZ=DZ+SQRT(ABS(WORK2(NRAD(ISORT))))
	DO 50 IRAD=0,NRAD(ISORT)
	DELRHO=(RO(IRAD,ISYM,IATOM,1)-RO(IRAD,ISYM,IATOM,NSPIN))-(
     &  ROOLD(IRAD,1)-ROOLD(IRAD,NSPIN))
	WORK1(IRAD)=WEIGHT(IRAD,IS(IATOM))*DCONJG(DELRHO)*
     &  DELRHO/4.D0/PI
  50    CONTINUE
	CALL CQD(H(IS(IATOM)),WORK1,WORK2,NRAD(ISORT)+1)
	DM=DM+SQRT(ABS(WORK2(NRAD(ISORT))))
C ADMIX NEW CHARGE DENSITY WITH THE OLD ONE
        IF(L.GT.LBROY)THEN                       !!! for l>l_broy
	DO 60 IRAD=0,NRAD(ISORT)
C 1. TOTAL CHARGE WITHIN MT-SPHERES
	ROOUT=(RO(IRAD,ISYM,IATOM,1)+RO(IRAD,ISYM,IATOM,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	ROINP=(ROOLD(IRAD,1)+ROOLD(IRAD,NSPIN))/2.D0*DBLE(NSPIN)
	RONEW=ADMOPT*ROOUT+(1.D0-ADMOPT)*ROINP
	AMOUT=(RO(IRAD,ISYM,IATOM,1)-RO(IRAD,ISYM,IATOM,NSPIN))
	AMINP=(ROOLD(IRAD,1)-ROOLD(IRAD,NSPIN))
	AMNEW=ADSPIN*AMOUT+(1.D0-ADSPIN)*AMINP
	RO(IRAD,ISYM,IATOM,1)=(RONEW+AMNEW)/DBLE(NSPIN)
	RO(IRAD,ISYM,IATOM,NSPIN)=(RONEW-AMNEW)/DBLE(NSPIN)
  60    CONTINUE
        ENDIF                                   !!! for l>l_broy
	ENDIF                                   !!! for non-zero components
  70    CONTINUE                                !!! over lm
	DO 80 IREAD=1,6
  80    READ(3)                                 !!! skip lines
 110    CONTINUE                                !!! over atoms in cell
	CLOSE(3)
	IF(ABS(DZ).LE.EPSRHO.AND.ABS(DM).LE.EPSMAG)EXIT=.TRUE.
	IF(ABS(DZ).GT.EPSRHO.OR .ABS(DM).GT.EPSMAG)EXIT=.FALSE.
	WRITE(IUN,1010)DZ,DI,ITER
	IF(NSPIN.EQ.2)WRITE(IUN,1020)DM,DMI
	IF(IUN.NE.IUT)
     &  WRITE(IUT,1010)DZ,DI,ITER
	IF(NSPIN.EQ.2.AND.IUN.NE.IUT)
     &  WRITE(IUT,1020)DM,DMI
        IF(LBROY.LT.0)THEN
        WRITE(IUN,1030)ADMOPT
        IF(NSPIN.EQ.2)WRITE(IUN,1040)ADSPIN
        CALL SCONVC(DZ,DI,ITER,ADMIN,ADMAX)
        CALL SCONVM(DM,DMI,ITER,ASMIN,ASMAX)
        ENDIF
1010    FORMAT(1X,'Charge Density Self-Consistency=',G14.7,2X,G14.7,
     &  3X,I4)
1020    FORMAT(1X,'Magnetization  Self-Consistency=',G14.7,2X,G14.7)
1030    FORMAT(1X,'Charge Density Optimal Admixing=',G14.7)
1040    FORMAT(1X,'Magnetization  Optimal Admixing=',G14.7)
	END




	SUBROUTINE PRATTC(A,ITER,KEY,ADM0,ADMIN,ADMAX,ADM)
************************************************************
*  Optimal admixture choice in solving the equation:       *
*                         A=F[A]                           *
*  according to the Pratt scheme.                          *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	SAVE AINPI,AINPIP1,AOUTI
	IF(ITER.EQ.0)RETURN
C  SET INPUT AND OUTPUT VALUES
	AINPIM1=AINPI         !!! A(inp,i-1)=A(inp,i)
	AINPI=AINPIP1         !!! A(inp,i)=A(inp,i+1)
	AOUTIM1=AOUTI         !!! A(out,i-1)=A(out,i)
	AOUTI=A               !!! A(out,i)=A coming now
C  FIND OPTIMAL ADMIXTURE
	IF(ITER.EQ.1.AND.KEY.EQ.0)THEN
	ADM=ADM0              !!! input admixture in case key=0
	ELSEIF(ITER.EQ.1.AND.KEY.EQ.1)THEN
	ADM=1.D0              !!! no admixture in case key=1
	ELSEIF(ITER.EQ.2.OR.ITER.EQ.3)THEN
	ADM=ADM0              !!! constant admixture
	ELSE                  !!! optimal admixture choice
	DIF=(AOUTI-AINPI)-(AOUTIM1-AINPIM1)
	IF(ABS(DIF).LE.1.D-10)THEN
	ADM=ADM0
	ELSE
	ADM=(AINPIM1-AINPI)/(DIF+1.D-14)
	ENDIF
	ENDIF
	IF(ADM.LE.ADMIN)ADM=ADMIN
	IF(ADM.GE.ADMAX)ADM=ADMAX
C  FIND INPUT FOR THE NEXT ITERATION
	AINPIP1=AOUTI*ADM+AINPI*(1.D0-ADM) !!! A(inp,i+1)               
	END



	SUBROUTINE PRATTM(A,ITER,KEY,ADM0,ADMIN,ADMAX,ADM)
************************************************************
*  Optimal admixture choice in solving the equation:       *
*                         A=F[A]                           *
*  according to the Pratt scheme.                          *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	SAVE AINPI,AINPIP1,AOUTI
	IF(ITER.EQ.0)RETURN
C  SET INPUT AND OUTPUT VALUES
	AINPIM1=AINPI         !!! A(inp,i-1)=A(inp,i)
	AINPI=AINPIP1         !!! A(inp,i)=A(inp,i+1)
	AOUTIM1=AOUTI         !!! A(out,i-1)=A(out,i)
	AOUTI=A               !!! A(out,i)=A coming now
C  FIND OPTIMAL ADMIXTURE
	IF(ITER.EQ.1.AND.KEY.EQ.0)THEN
	ADM=ADM0              !!! input admixture in case key=0
	ELSEIF(ITER.EQ.1.AND.KEY.EQ.1)THEN
	ADM=1.D0              !!! no admixture in case key=1
	ELSEIF(ITER.EQ.2.OR.ITER.EQ.3)THEN
	ADM=ADM0              !!! constant admixture
	ELSE                  !!! optimal admixture choice
	DIF=(AOUTI-AINPI)-(AOUTIM1-AINPIM1)
	IF(ABS(DIF).LE.1.D-14)THEN
	ADM=ADM0
	ELSE
	ADM=(AINPIM1-AINPI)/(DIF+1.D-14)
	ENDIF
	ENDIF
	IF(ADM.LE.ADMIN)ADM=ADMIN
	IF(ADM.GE.ADMAX)ADM=ADMAX
C  FIND INPUT FOR THE NEXT ITERATION
	AINPIP1=AOUTI*ADM+AINPI*(1.D0-ADM) !!! A(inp,i+1)               
	END



        SUBROUTINE SCONVC(A,AI,ITER,ADMIN,ADMAX)
************************************************************
*  Checks whether the self-consistent cycle converges.     *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION AOLD(2),AIOLD(2)
        SAVE AOLD,AIOLD
C  SAVE DATA OF PREVIOUS THREE ITERATIONS
        IF(ITER.EQ.1)THEN
        AOLD(1)=0.D0
        AOLD(2)=0.D0
        AIOLD(1)=0.D0
        AIOLD(2)=0.D0
        ELSEIF(ITER.GT.1)THEN
        AOLD(2)=AOLD(1)
        AOLD(1)=A
        AIOLD(2)=AIOLD(1)
        AIOLD(1)=AI
        ENDIF
C  CHECK WHETHER CONVERGENCY IS TAKEN PLACE
        IF(ITER.GT.3)THEN
        IF(AOLD(1).LE.AOLD(2).AND.AIOLD(1).LE.AIOLD(2))RETURN
        ADMIN=ADMIN/2.D0
        ADMAX=ADMAX/2.D0
        ENDIF
        END



        SUBROUTINE SCONVM(A,AI,ITER,ADMIN,ADMAX)
************************************************************
*  Checks whether the self-consistent cycle converges.     *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION AOLD(2),AIOLD(2)
        SAVE AOLD,AIOLD
C  SAVE DATA OF PREVIOUS THREE ITERATIONS
        IF(ITER.EQ.1)THEN
        AOLD(1)=0.D0
        AOLD(2)=0.D0
        AIOLD(1)=0.D0
        AIOLD(2)=0.D0
        ELSEIF(ITER.GT.1)THEN
        AOLD(2)=AOLD(1)
        AOLD(1)=A
        AIOLD(2)=AIOLD(1)
        AIOLD(1)=AI
        ENDIF
C  CHECK WHETHER CONVERGENCY IS TAKEN PLACE
        IF(ITER.GT.3)THEN
        IF(AOLD(1).LE.AOLD(2).AND.AIOLD(1).LE.AIOLD(2))RETURN
        ADMIN=ADMIN/2.D0
        ADMAX=ADMAX/2.D0
        ENDIF
        END
