	SUBROUTINE PULEND(IPAN)
***********************************************************
*  Makes final contribution to the Pulay force.           *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NKAP(NPANMAX),NPNT(NPANMAX),NDIV(3),NDIC(3)
	COMPLEX*16 YLM(LIMLMB,0:NBASMAX),CTMP,CONT1(0:NBASMAX,3)
     &    ,VPS(0:NPLWMAX,NSPINMAX),VPSINT(0:NPLWMAX,NSPINMAX)
     &    ,EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX)
     &    ,CFTR(0:LMAXB,NSORTMAX,NKAPMAX,0:NBASMAX)
     &    ,PILF(-1:1,NPAT,NDIMMAX,2),RHOPS(0:NPLWMAX,NSPINMAX)
     &    ,EXPS(0:NPLWMAX),CHIS(0:NBASMAX),CONV(0:NBASMAX)
     &    ,EXPK(0:NPLWMAX),CHIK(0:NBASMAX),CONR(0:NBASMAX)
     &    ,RFUN(NDIMMAX,0:MBASMAX),RINT0(NDIMMAX,NDIMMAX)
     &    ,PFI(3,NPAT),PFM(-1:1,NPAT)
     &    ,PFVAL(-1:1,NPAT,NPANMAX,NSPINMAX,2)
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &    ,PNTR(3),PNTK(3),PNT(3,KMAX,NPANMAX),WGT(KMAX,NPANMAX)
     &    ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),SH(3,NPANMAX)
     &    ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR,NPF                !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /BASIS/  TAU                                  !!! from init
	COMMON /POTCOM/ SWZ,SMT                              !!! from init
        COMMON /LATPAR/ PAR                                  !!! from init
	COMMON /DENS/   PNTR,CFTR,YLM                        !!! from strgnt
        COMMON /PSVCOM/ VPS,VPSINT                           !!! from vpseudo
	COMMON /PSRHO/  RHOPS                                !!! from tosint
        COMMON /STORE1/ RFUN,RINT0                           !!! tmp.storage
        COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from plwmsh
	COMMON /PILAUF/ PFVAL,PILF                           !!! from lmtvar
	COMMON /MESH/   NPNT,PNT,WGT                         !!! from ttrmsh
	COMMON /SPIN/   NSPIN                                !!! from init
        COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
        COMMON /INTTR/  NDIV,NDIC,SH                         !!! from init
	COMMON /INDX/   IND                                  !!! from lmtpar
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
        IF(KEYT.EQ.0)RETURN
        IF(NPF .EQ.0)RETURN
        PNTK(1)=0.D0
        PNTK(2)=0.D0
        PNTK(3)=0.D0
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
        CALL FTRMAT(PNTK,1,IPAN)
C  DO OVER SPINS
	DO 1000 ISPIN=1,NSPIN                       !!! over spins
        IREC=ISPIN
        READ(19,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  SET ZEROES
	DO INUC=1,NATOM	
	DO IXYZ=1,3
	PFI(IXYZ,INUC)=(0.D0,0.D0)
	ENDDO
	ENDDO
C  DO OVER LEFT INDEX
        DO IATOM1=1,NATOM                           !!! over iatom1
        ISORT1=IS(IATOM1)
	INUC1=IATOM1                                !!! <--- displacing atom
C  CALCULATE EXPONENTIAL FACTOR
        DO IBAS=0,NBAS
        SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
        EXPS(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
        DO IKAP1=1,NKAP(IPAN)                       !!! over energy
        DO L1=0,ILSB(ISORT1)                        !!! over l1
        DO M1=-L1,L1                                !!! over m1
        IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
        L1M1=L1*(L1+1)+M1+1
        IPAR1=IND(L1M1,IATOM1,IKAP1,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
        DO IBAS=MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN)   !!! NG_1{large}
        CHIS(IBAS)=DCONJG(CFTR(L1,ISORT1,IKAP1,IBAS)*
     &  YLM(L1M1,IBAS)*EXPS(IBAS))
	ENDDO
	DO IBAS=0,MIN(NBAS,MBAS)
	CHIK(IBAS)=RFUN(IPAR1,IBAS)
	ENDDO
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
        CALL CONVOL1(VPSINT(0,ISPIN),CHIS(0),CONV(0),'L',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
        CALL CONVOL1(VPSINT(0,ISPIN),CHIK(0),CONR(0),'R',
     &               MBAS+1,NBAS,0,MIN(NBAS,MBAS))
C  DO OVER POLARIZATIONS
	DO IXYZ=1,3                                 !!! over xyz
C  1) SMALL-SMALL G CONTRIBUTION : HAS BEEN DONE BEFORE
C  2) SMALL-LARGE G CONTRIBUTION
	DO IBAS=MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN)
   	PFI(IXYZ,INUC1)=PFI(IXYZ,INUC1)+(0.D0,1.D0)*
     &	CHIS(IBAS)*CONR(IBAS)*GPLW(IXYZ,IBAS)*2.D0*PI/PAR
	ENDDO
        ENDDO                                       !!! over xyz
C  SET CONVOLUTION OF PSEUDOORBITAL WITH TOS-MATRIX
        DO INUC=1,NATOM                             !!! over iatom
	IATOM=INUC
        ISORT=IS(IATOM)
	DO IXYZ=1,3
	DO IBAS=0,NBAS
	CONT1(IBAS,IXYZ)=(0.D0,0.D0)
	ENDDO
	ENDDO
C  CALCULATE EXPONENTIAL FACTOR
        DO IBAS=0,NBAS                              !!! NGMAX{large}
        SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
        EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO 
        DO IKAP=1,NKAP(IPAN)                        !!! over energy
        DO L=0,ILSB(ISORT)                          !!! over l
        DO M=-L,L                                   !!! over m
        IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
        LM=L*(L+1)+M+1
        IPAR=IND(LM,IATOM,IKAP,1,IPAN)
C  SET LOWER PART OF THE MATRIX
        IF(IPAR1.LT.IPAR)
     &  RINT0(IPAR1,IPAR)=DCONJG(RINT0(IPAR,IPAR1))
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
        DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
        CHIK(IBAS)=CFTR(L,ISORT,IKAP,IBAS)*YLM(LM,IBAS)*EXPK(IBAS)
	ENDDO
C  DO OVER POLARIZATIONS
	DO IXYZ=1,3                                 !!! over xyz
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
	CONT1(IBAS,IXYZ)=CONT1(IBAS,IXYZ)+RINT0(IPAR1,IPAR)*
     &  CHIK(IBAS)*(0.D0,1.D0)*GPLW(IXYZ,IBAS)*2.D0*PI/PAR
        ENDDO    
        ENDDO                                       !!! over m
        ENDDO                                       !!! over l
        ENDDO                                       !!! over energy
        ENDDO                                       !!! over xyz
C  4) LARGE-LARGE G CONTRIBUTION
	DO IXYZ=1,3                                 !!! over xyz
	DO IBAS=MBAS+1,NBAS
	PFI(IXYZ,INUC)=PFI(IXYZ,INUC)-CONV(IBAS)*CONT1(IBAS,IXYZ)
        ENDDO
        ENDDO                                       !!! over xyz
        ENDDO                                       !!! over inuc
        ENDDO                                       !!! over m1
        ENDDO                                       !!! over l1
        ENDDO                                       !!! over energy
        ENDDO                                       !!! over iatom1
C  TRANSFERE TO SPHERICAL COORDINATE SYSTEM
        DO INUC=1,NATOM
	DO IXYZ=1,3
        PFI(IXYZ,INUC)=PFI(IXYZ,INUC)+DCONJG(PFI(IXYZ,INUC))
	ENDDO
        PFM(-1,INUC)=+1.D0/SQRT(2.D0)*
     &                    (PFI(1,INUC)-(0.D0,1.D0)*PFI(2,INUC))
        PFM(+1,INUC)=-1.D0/SQRT(2.D0)*
     &                    (PFI(1,INUC)+(0.D0,1.D0)*PFI(2,INUC))
        PFM(0,INUC)=PFI(3,INUC)
	DO MY=-1,1
        PFVAL(MY,INUC,IPAN,ISPIN,2)=PFVAL(MY,INUC,IPAN,ISPIN,2)+
     &  PFM(MY,INUC)
	ENDDO
	ENDDO
1000	CONTINUE                                    !!! over spins
C  DO AGAIN OVER POLARIZATIONS AND SPINS 
	DO 3000 ISPIN=1,NSPIN                       !!! over spins
	DO 2000 IXYZ=1,3                            !!! over xyz
        IREC=ISPIN+NSPIN*(IXYZ-1)
        READ(20,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  SET ZEROES
	DO INUC=1,NATOM	
	PFI(IXYZ,INUC)=(0.D0,0.D0)
	ENDDO
C  DO OVER LEFT INDEX
        DO IATOM1=1,NATOM                           !!! over iatom1
        ISORT1=IS(IATOM1)
	INUC1=IATOM1                                !!! <--- displacing atom
C  CALCULATE EXPONENTIAL FACTOR
        DO IBAS=0,NBAS
        SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
        EXPS(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
        DO IKAP1=1,NKAP(IPAN)                       !!! over energy
        DO L1=0,ILSB(ISORT1)                        !!! over l1
        DO M1=-L1,L1                                !!! over m1
        IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
        L1M1=L1*(L1+1)+M1+1
        IPAR1=IND(L1M1,IATOM1,IKAP1,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
        DO IBAS=MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN)   !!! NG_1{large}
        CHIS(IBAS)=DCONJG(CFTR(L1,ISORT1,IKAP1,IBAS)*
     &  YLM(L1M1,IBAS)*EXPS(IBAS))
	ENDDO
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
        CALL CONVOL1(VPSINT(0,ISPIN),CHIS(0),CONV(0),'L',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
C  1) SMALL-SMALL G CONTRIBUTION : HAS BEEN DONE BEFORE
C  2) LARGE-SMALL G CONTRIBUTION
	DO IBAS=0,MIN(NBAS,MBAS)
   	PFI(IXYZ,INUC1)=PFI(IXYZ,INUC1)+(0.D0,1.D0)*
     &	CONV(IBAS)*RFUN(IPAR1,IBAS)
        ENDDO                                       !!! over ibas
C  SET CONVOLUTION OF PSEUDOORBITAL WITH TOS-MATRIX
        DO INUC=1,NATOM                             !!! over iatom
	IATOM=INUC
        ISORT=IS(IATOM)
	DO IBAS=0,NBAS
	CONT1(IBAS,1)=(0.D0,0.D0)
	ENDDO
C  CALCULATE EXPONENTIAL FACTOR
        DO IBAS=0,NBAS                              !!! NGMAX{large}
        SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
        EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
        DO IKAP=1,NKAP(IPAN)                        !!! over energy
        DO L=0,ILSB(ISORT)                          !!! over l
        DO M=-L,L                                   !!! over m
        IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
        LM=L*(L+1)+M+1
        IPAR=IND(LM,IATOM,IKAP,1,IPAN)
C  SET LOWER PART OF THE MATRIX
        IF(IPAR1.LT.IPAR)
     &  RINT0(IPAR1,IPAR)=DCONJG(RINT0(IPAR,IPAR1))
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
        DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
        CHIK(IBAS)=CFTR(L,ISORT,IKAP,IBAS)*YLM(LM,IBAS)*EXPK(IBAS)
	ENDDO
C  CONVOLUTION
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
	CONT1(IBAS,1)=CONT1(IBAS,1)+RINT0(IPAR1,IPAR)*
     &  CHIK(IBAS)*(0.D0,1.D0)
	ENDDO
        ENDDO                                      !!! over m
        ENDDO                                      !!! over l
        ENDDO                                      !!! over energy
C  4) LARGE-LARGE G CONTRIBUTION
	DO IBAS=MBAS+1,NBAS
	PFI(IXYZ,INUC)=PFI(IXYZ,INUC)-CONV(IBAS)*CONT1(IBAS,1)
        ENDDO                                      !!! over ibas
        ENDDO                                      !!! over inuc
        ENDDO                                      !!! over m1
        ENDDO                                      !!! over l1
        ENDDO                                      !!! over energy
        ENDDO                                      !!! over iatom1
2000	CONTINUE                                   !!! over polarizations
C  TRANSFERE TO SPHERICAL COORDINATE SYSTEM
        DO INUC=1,NATOM
	DO IXYZ=1,3
        PFI(IXYZ,INUC)=PFI(IXYZ,INUC)+DCONJG(PFI(IXYZ,INUC))
	ENDDO
        PFM(-1,INUC)=+1.D0/SQRT(2.D0)*
     &                    (PFI(1,INUC)-(0.D0,1.D0)*PFI(2,INUC))
        PFM(+1,INUC)=-1.D0/SQRT(2.D0)*
     &                    (PFI(1,INUC)+(0.D0,1.D0)*PFI(2,INUC))
        PFM(0,INUC)=PFI(3,INUC)
	DO MY=-1,1
        PFVAL(MY,INUC,IPAN,ISPIN,2)=PFVAL(MY,INUC,IPAN,ISPIN,2)+
     &  PFM(MY,INUC)
	ENDDO
	ENDDO
3000	CONTINUE                                   !!! over spins
	END
