	SUBROUTINE RHOFUL
**********************************************************
* The calculation of the  full valence density           *
* whithin MT-spheres by one-center expansions.           *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT),LR(NSORTMAX)
     &   ,NKAP(NPANMAX),IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NRAD(NSORTMAX)
	DIMENSION ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),R(0:NRADMAX,NSORTMAX)
     &   ,FID(0:NRADMAX,0:LMAXT),FI(0:NRADMAX,0:LMAXT)
     &   ,FIP(0:NRADMAX,0:LMAXT),FIDP(0:NRADMAX,0:LMAXT)
     &   ,FIDDS(0:LMAXT),FIDDPS(0:LMAXT),DR(0:NRADMAX,NSORTMAX)
     &   ,C(0:LMAXV+1,LMMAXV1,LMMAXV1),GAM(0:LMAXT,NSORTMAX)
     &   ,H(NSORTMAX),SMT(NSORTMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),CGNT
     &   ,ATOSHH(LIMLMB,LIMLMB,NPAT),ATOSJJ(LIMLMT,LIMLMT,NPAT)
     &   ,ATOSHJ(LIMLMB,LIMLMT,NPAT),ATOSJH(LIMLMT,LIMLMB,NPAT)
     &   ,AAH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,AAJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,BBH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,BBJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,FIH(0:NRADMAX,0:LMAXT,NKAPMAX),T(4)
     &   ,FIHD(0:NRADMAX,0:LMAXT,NKAPMAX)
     &   ,FIJ(0:NRADMAX,0:LMAXT,NKAPMAX)
     &   ,FIJD(0:NRADMAX,0:LMAXT,NKAPMAX)
     &   ,FIHDD(0:LMAXT,NKAPMAX),FIJDD(0:LMAXT,NKAPMAX)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
	LOGICAL SYM(LMMAXV,NPAT),LOG1,LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
	CHARACTER*10 TXTEL(NSORTMAX)
C Controls:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
	COMMON /RELATIV/LR                                   !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT,VSPH                         !!! from vfull
	COMMON /INPPAR/ TNY,ENY                              !!! from seteny
	COMMON /LMTPAR/ GAM,AAH,BBH,AAJ,BBJ                  !!! from potpar
	COMMON /KAPPAR/ NPAN,NKAP                            !!! from readini
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from readini
	COMMON /SYMMLM/ SYM,LMSYM                            !!! from symmlm
C Density:
	COMMON /DENS/   RO,ROVALDS                           !!! from rhoful
C Temporary:
	COMMON /STORE1/ ATOSHH,ATOSJH,ATOSHJ,ATOSJJ          !!! from ttrint
	COMMON /STORE2/ FI,FID,FIP,FIDP,FIH,FIHD,FIJ,FIJD    !!! tmp.storage
C Gaunts:
	COMMON /GAUNT/  C                                    !!! from gdata
C Rad.mesh:
	COMMON /RADMESH/NRAD,H,R,DR                          !!! from radmsh    
C Outputs:
	COMMON /UNIT/   IUN                                  !!! from readini
	COMMON /TXTEL/  TXTEL                                !!! from readini
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	DO 5000 ISPIN=1,NSPIN                  !!! over spins
	DO 4000 IPAN=1,NPAN                    !!! over panels
	NSHIFT1=0
	NSHIFT2=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)NSHIFT1=NSHIFT1+NKAP(JPAN)**2
	NSHIFT2=NSHIFT2+NKAP(JPAN)**2
	ENDDO 
	DO 3000 IATOM=1,NATOM                  !!! over atoms in cell
	ISORT=IS(IATOM)
	DO  IKAP=1,NKAP(IPAN)                  !!! over energies
        CALL DFIFID(ENY(0,ISORT,IKAP,IPAN,ISPIN),FI,FIP,FID,FIDP,
     &  FIDDS,FIDDPS,SMT(ISORT),VSPH(0,ISORT,ISPIN),ILST(ISORT),
     &  NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),LR(ISORT))
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*FI(IRAD,L)+
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)
	FIJ(IRAD,L,IKAP)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*FI(IRAD,L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)
	FIHD(IRAD,L,IKAP)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*FID(IRAD,L)+
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)*FIDP(IRAD,L)
	FIJD(IRAD,L,IKAP)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*FID(IRAD,L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*FIDP(IRAD,L)
	ENDDO 
	FIHDD(L,IKAP)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*FIDDS(L)+
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)*FIDDPS(L)
	FIJDD(L,IKAP)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*FIDDS(L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*FIDDPS(L)
	ENDDO 
        ENDDO                                  !!! over energies
	DO L2=0,ILSV(ISORT)                    !!! over l2
	DO M2=-L2,L2                           !!! over m2
	LM2=L2*(L2+1)+M2+1
	IF(SYM(LM2,IATOM))THEN
	ISYM=LMSYM(LM2,IATOM)
	DO IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	IF(IPAN.EQ.1)RO(IRAD,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
        ENDDO                                  !!! over radial mesh
	DO ID=1,3                              !!! over derivatives
	IF(IPAN.EQ.1)ROVALDS(ID,ISYM,IATOM,ISPIN)=(0.0,0.0)
        ENDDO                                  !!! over derivatives
	ENDIF
        ENDDO                                  !!! over m2
        ENDDO                                  !!! over l2
	DO 2000 IKAP1=1,NKAP(IPAN)             !!! over energies
	DO 1000 IKAP=1,NKAP(IPAN)              !!! over energies
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NSHIFT1*NATOM+NSHIFT2*NATOM*(ISPIN-1)
	READ(21,REC=IREC)((ATOSHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((ATOSJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	DO L1=0,ILST(ISORT)                    !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                           !!! over m1
	LM1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)                     !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
	DO L2=ABS(L1-L),L1+L,2                 !!! over l2 (expansion of ro)
	IF(L2.LE.ILSV(ISORT))THEN
	M2=M-M1
	LM2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2)THEN                  !!! over m2 (expansion of ro)
	IF(SYM(LM2,IATOM))THEN
	ISYM=LMSYM(LM2,IATOM)
	CGNT=(0.D0,1.D0)**(L-L1-L2)*C(L2/2,LM,LM1)
	DO IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	IF(LOG1.AND.LOG)
     &  RO(IRAD,ISYM,IATOM,ISPIN)=RO(IRAD,ISYM,IATOM,ISPIN)+
     &  (ATOSHH(LM1,LM,IATOM)*
     &  CONJG(FIH(IRAD,L1,IKAP1))*FIH(IRAD,L,IKAP))*CGNT
	IF(LOG1)
     &  RO(IRAD,ISYM,IATOM,ISPIN)=RO(IRAD,ISYM,IATOM,ISPIN)-
     &  (ATOSHJ(LM1,LM,IATOM)*
     &  CONJG(FIH(IRAD,L1,IKAP1))*FIJ(IRAD,L,IKAP)*GAM(L,ISORT))*CGNT
	IF(LOG)
     &  RO(IRAD,ISYM,IATOM,ISPIN)=RO(IRAD,ISYM,IATOM,ISPIN)-
     &  (ATOSJH(LM1,LM,IATOM)*
     &  CONJG(FIJ(IRAD,L1,IKAP1))*FIH(IRAD,L,IKAP)*GAM(L1,ISORT))*CGNT
	RO(IRAD,ISYM,IATOM,ISPIN)=RO(IRAD,ISYM,IATOM,ISPIN)+
     &  (ATOSJJ(LM1,LM,IATOM)*
     &  CONJG(FIJ(IRAD,L1,IKAP1))*FIJ(IRAD,L,IKAP)*GAM(L1,ISORT)
     &  *GAM(L,ISORT))*CGNT
        ENDDO                                  !!! over radial mesh
	ROVALDS(1,ISYM,IATOM,ISPIN)=RO(NRAD(ISORT),ISYM,IATOM,ISPIN)
	IF(LOG1.AND.LOG)
     &  ROVALDS(2,ISYM,IATOM,ISPIN)=ROVALDS(2,ISYM,IATOM,ISPIN)+
     &  ATOSHH(LM1,LM,IATOM)*CGNT*
     &  (CONJG(FIH(NRAD(ISORT),L1,IKAP1))*FIHD(NRAD(ISORT),L,IKAP)
     &  +CONJG(FIHD(NRAD(ISORT),L1,IKAP1))*FIH(NRAD(ISORT),L,IKAP))
	IF(LOG1)
     &  ROVALDS(2,ISYM,IATOM,ISPIN)=ROVALDS(2,ISYM,IATOM,ISPIN)-
     &  ATOSHJ(LM1,LM,IATOM)*CGNT*GAM(L,ISORT)*
     &  (CONJG(FIHD(NRAD(ISORT),L1,IKAP1))*FIJ(NRAD(ISORT),L,IKAP)
     &  +CONJG(FIH(NRAD(ISORT),L1,IKAP1))*FIJD(NRAD(ISORT),L,IKAP))
	IF(LOG)
     &  ROVALDS(2,ISYM,IATOM,ISPIN)=ROVALDS(2,ISYM,IATOM,ISPIN)-
     &  ATOSJH(LM1,LM,IATOM)*CGNT*GAM(L1,ISORT)*
     &  (CONJG(FIJ(NRAD(ISORT),L1,IKAP1))*FIHD(NRAD(ISORT),L,IKAP)
     &  +CONJG(FIJD(NRAD(ISORT),L1,IKAP1))*FIH(NRAD(ISORT),L,IKAP))
	ROVALDS(2,ISYM,IATOM,ISPIN)=ROVALDS(2,ISYM,IATOM,ISPIN)+
     &  ATOSJJ(LM1,LM,IATOM)*CGNT*GAM(L1,ISORT)*GAM(L,ISORT)*
     &  (CONJG(FIJD(NRAD(ISORT),L1,IKAP1))*FIJ(NRAD(ISORT),L,IKAP)
     &  +CONJG(FIJ(NRAD(ISORT),L1,IKAP1))*FIJD(NRAD(ISORT),L,IKAP))
	ROVALDS(3,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
	ENDIF
	ENDIF                                  !!! over m2
	ENDIF                                  !!!      l2
        ENDDO                                  !!! over l2 
        ENDDO                                  !!! over m
        ENDDO                                  !!! over l
        ENDDO                                  !!! over m1
        ENDDO                                  !!! over l1
1000    CONTINUE                               !!! over energies
2000    CONTINUE                               !!! over energies
3000    CONTINUE                               !!! over all atoms in cell
4000    CONTINUE                               !!! over panels
5000    CONTINUE                               !!! over spins
	END


	SUBROUTINE SRODOT
**********************************************************
* The calculation of the change in charge density due to *
* shift in Eny. Only for evaluating linear response      *
* corrections to atomic forces is necessary.             *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT),LR(NSORTMAX)
     &   ,NKAP(NPANMAX),IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NRAD(NSORTMAX)
	DIMENSION ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),R(0:NRADMAX,NSORTMAX)
     &   ,FID (0:NRADMAX,0:LMAXT),FI   (0:NRADMAX,0:LMAXT)
     &   ,FIP (0:NRADMAX,0:LMAXT),FIDP (0:NRADMAX,0:LMAXT)
     &   ,FIPP(0:NRADMAX,0:LMAXT),FIDPP(0:NRADMAX,0:LMAXT)
     &   ,C(0:LMAXV+1,LMMAXV1,LMMAXV1),GAM(0:LMAXT,NSORTMAX)
     &   ,GGNT(0:LMAXV+1,0:LMAXV+1,0:LMAXV+1),SMT(NSORTMAX)
     &   ,RHODOT(0:NRADMAX,NSORTMAX,NSPINMAX)
     &   ,H(NSORTMAX),DR(0:NRADMAX,NSORTMAX)
	COMPLEX*16 FIH(0:NRADMAX,0:LMAXT,NKAPMAX),T(4)
     &   ,FIHP(0:NRADMAX,0:LMAXT,NKAPMAX),CGNT,WORK1(0:NRADMAX)
     &   ,FIJ(0:NRADMAX,0:LMAXT,NKAPMAX),WORK2(0:NRADMAX)
     &   ,FIJP(0:NRADMAX,0:LMAXT,NKAPMAX),AAHP,AAJP,BBHP,BBJP
     &   ,ATOSHH(LIMLMB,LIMLMB,NPAT),ATOSJJ(LIMLMT,LIMLMT,NPAT)
     &   ,ATOSHJ(LIMLMB,LIMLMT,NPAT),ATOSJH(LIMLMT,LIMLMB,NPAT)
     &   ,AAH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,AAJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,BBH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,BBJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,HS (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,BS (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DH (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DJ (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,RODOT(0:NRADMAX,NSYMMAX),RESRHO(NPAT,NPANMAX,NSPINMAX)
     &   ,PFVAL(-1:1,NPAT,NPANMAX,NSPINMAX,2)
	LOGICAL SYM(LMMAXV,NPAT),LOG1,LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
	CHARACTER*10 TXTEL(NSORTMAX)
C Controls:
	COMMON /CONTROL/MAN,LMTO,NLR,NINT,NPF                !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
	COMMON /RELATIV/LR                                   !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT,VSPH,V                       !!! from vfull
	COMMON /INPPAR/ TNY,ENY,DNY                          !!! from readini
	COMMON /KAPPAR/ NPAN,NKAP                            !!! from readini
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from readini
	COMMON /SYMMLM/ SYM,LMSYM                            !!! from symmlm
C Pot.pars:
	COMMON /ASAPAR/ HS,BS,DH,DJ                          !!! from potpar
	COMMON /LMTPAR/ GAM,AAH,BBH,AAJ,BBJ                  !!! from potpar
C Temporary:
	COMMON /STORE1/ ATOSHH,ATOSJH,ATOSHJ,ATOSJJ          !!! from ttrint
	COMMON /STORE2/ FI,FID,FIP,FIDP,FIPP,FIDPP,FIH,FIHP,FIJ,FIJP
C Forces:
	COMMON /PILAUF/ PFVAL,RESRHO                         !!! from rhodot
C Gaunts:
	COMMON /GAUNT/  C,GGNT                               !!! from gaunt
C Radial mesh:
	COMMON /RADMESH/NRAD,H,R,DR                          !!! from radmsh    
C Outputs:
	COMMON /UNIT/   IUN                                  !!! from readini
	COMMON /TXTEL/  TXTEL                                !!! from readini
	DATA PI/3.141592653589793D0/
	IF(NPF.EQ.0)RETURN
	SQPI4=2.D0*SQRT(PI)
	DO 3000 ISPIN=1,NSPIN                  !!! over spins
	DO 2000 IPAN=1,NPAN                    !!! over panels
	NSHIFT1=0
	NSHIFT2=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)NSHIFT1=NSHIFT1+NKAP(JPAN)**2
	NSHIFT2=NSHIFT2+NKAP(JPAN)**2
	ENDDO 
	DO 1000 IATOM=1,NATOM                  !!! over atoms in cell
	DO IKAP=1,NKAP(IPAN)                   !!! over energies
	ISORT=IS(IATOM)
        CALL PFIFIP(ENY(0,ISORT,IKAP,IPAN,ISPIN),FI,FIP,FID,FIDP,
     &  FIPP,FIDPP,SMT(ISORT),VSPH(0,ISORT,ISPIN),ILST(ISORT),
     &  NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),LR(ISORT))
	DO L=0,ILST(ISORT)
C       DNYPP=SMT(ISORT)*FIDPP(NRAD(ISORT),L)/FIPP(NRAD(ISORT),L)
	DNYPP=DNY(L,ISORT,IKAP,IPAN,ISPIN)     !!! <--- property !!!
	AAHP=SMT(ISORT)*FIPP(NRAD(ISORT),L)*
     &  HS(L,ISORT,IKAP,IPAN,ISPIN)*
     &  (DH(L,ISORT,IKAP,IPAN,ISPIN)-DNYPP)
	AAJP=SMT(ISORT)*FIPP(NRAD(ISORT),L)*
     &  BS(L,ISORT,IKAP,IPAN,ISPIN)* 
     &  (DJ(L,ISORT,IKAP,IPAN,ISPIN)-DNYPP)
	BBHP=-AAH(L,ISORT,IKAP,IPAN,ISPIN) 
	BBJP=-AAJ(L,ISORT,IKAP,IPAN,ISPIN) 
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*FI(IRAD,L)+
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)
	FIJ(IRAD,L,IKAP)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*FI(IRAD,L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)
	FIHP(IRAD,L,IKAP)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)+
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)*FIPP(IRAD,L)+AAHP*FI(IRAD,L)+
     &  BBHP*FIP(IRAD,L)
	FIJP(IRAD,L,IKAP)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*FIPP(IRAD,L)+AAJP*FI(IRAD,L)+
     &  BBJP*FIP(IRAD,L)
	ENDDO
	ENDDO
        ENDDO                                  !!! over energies
C  SET CONTRIBUTION FOR GIVEN SPIN,L PANEL TO ZERO
	DO L2=0,ILSV(ISORT)                    !!! over l2
	DO M2=-L2,L2                           !!! over m2
	LM2=L2*(L2+1)+M2+1
	IF(SYM(LM2,IATOM))THEN
	ISYM=LMSYM(LM2,IATOM)
	DO IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	RODOT(IRAD,ISYM)=(0.D0,0.D0)
        ENDDO                                  !!! over radial mesh
	ENDIF
        ENDDO                                  !!! over m2
        ENDDO                                  !!! over l2
	IF(IPAN.EQ.1)THEN
	DO IRAD=0,NRAD(ISORT)
	RHODOT(IRAD,ISORT,ISPIN)=0.D0
	ENDDO 
	ENDIF
	DO IKAP1=1,NKAP(IPAN)                  !!! over energies
	DO IKAP=1,NKAP(IPAN)                   !!! over energies
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NSHIFT1*NATOM+NSHIFT2*NATOM*(ISPIN-1)
	READ(21,REC=IREC)((ATOSHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((ATOSJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	DO L1=0,ILST(ISORT)                    !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                           !!! over m1
	LM1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)                     !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
	DO L2=ABS(L1-L),L1+L,2                 !!! over l2 (expansion of ro)
	M2=M-M1
	LM2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2.AND.L2.LE.ILSV(ISORT))THEN
	IF(SYM(LM2,IATOM))THEN
	ISYM=LMSYM(LM2,IATOM)
	CGNT=(0.D0,1.D0)**(L-L1-L2)*C(L2/2,LM,LM1)
	DO IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	IF(LOG1.AND.LOG)
     &  RODOT(IRAD,ISYM)=RODOT(IRAD,ISYM)+
     &  ATOSHH(LM1,LM,IATOM)*
     &  (CONJG(FIH(IRAD,L1,IKAP1))*FIHP(IRAD,L,IKAP)+
     &  CONJG(FIHP(IRAD,L1,IKAP1))*FIH(IRAD,L,IKAP))*CGNT
	IF(LOG1)
     &  RODOT(IRAD,ISYM)=RODOT(IRAD,ISYM)-
     &  ATOSHJ(LM1,LM,IATOM)*
     &  (CONJG(FIH(IRAD,L1,IKAP1))*FIJP(IRAD,L,IKAP)+
     &  CONJG(FIHP(IRAD,L1,IKAP1))*FIJ(IRAD,L,IKAP))*
     &  GAM(L,ISORT)*CGNT
	IF(LOG)
     &  RODOT(IRAD,ISYM)=RODOT(IRAD,ISYM)-
     &  ATOSJH(LM1,LM,IATOM)*
     &  (CONJG(FIJ(IRAD,L1,IKAP1))*FIHP(IRAD,L,IKAP)+
     &  CONJG(FIJP(IRAD,L1,IKAP1))*FIH(IRAD,L,IKAP))*
     &  GAM(L1,ISORT)*CGNT
	RODOT(IRAD,ISYM)=RODOT(IRAD,ISYM)+
     &  ATOSJJ(LM1,LM,IATOM)*
     &  (CONJG(FIJ(IRAD,L1,IKAP1))*FIJP(IRAD,L,IKAP)+
     &  CONJG(FIJP(IRAD,L1,IKAP1))*FIJ(IRAD,L,IKAP))*
     &  GAM(L1,ISORT)*GAM(L,ISORT)*CGNT
        ENDDO                                  !!! over radial mesh
	ENDIF
	ENDIF                                  !!! over m2 (expansion of ro)
        ENDDO                                  !!! over l2 (expansion of ro)
        ENDDO                                  !!! over m
        ENDDO                                  !!! over l
        ENDDO                                  !!! over m1
        ENDDO                                  !!! over l1
        ENDDO                                  !!! over energies
        ENDDO                                  !!! over energies
C  SAVE SPHERICAL CONTRIBUTION TO THE RESPONSE
	DO IRAD=0,NRAD(ISORT)
	RHODOT(IRAD,ISORT,ISPIN)=RHODOT(IRAD,ISORT,ISPIN)+
     &  RODOT(IRAD,1)
	ENDDO
	IF(ABS(RODOT(NRAD(ISORT),1)).GE.1.D-06)PRINT*,
     &  '<SRODOT>: NO ACCURACY IN RHODOT ','1',RODOT(NRAD(ISORT),1)
C  CALCULATE INTEGRAL OF RODOT WITH THE NMT-PART OF THE POTENTIAL
	RESRHO(IATOM,IPAN,ISPIN)=(0.D0,0.D0)
	DO L=1,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=CONJG(RODOT(IRAD,ISYM))*V(IRAD,ISYM,IATOM,ISPIN)*
     &  R(IRAD,ISORT)**2*DR(IRAD,ISORT)
	ENDDO
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RESRHO(IATOM,IPAN,ISPIN)=RESRHO(IATOM,IPAN,ISPIN)+
     &  WORK2(NRAD(ISORT))
	IF(ABS(RODOT(NRAD(ISORT),ISYM)).GE.1.D-06)PRINT*,
     &  '<SRODOT>: NO ACCURACY IN RHODOT',LM,RODOT(NRAD(ISORT),ISYM)
	ENDIF
	ENDDO 
	ENDDO 
1000    CONTINUE                               !!! over all atoms in cell
2000    CONTINUE                               !!! over panels
3000    CONTINUE                               !!! over spins
	END
